/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.99 Revision 1.124
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.99 2010/05/25 19:49:54 arfrever Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.124 2011/07/08 07:46:53 djc Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Gentoo Python Project <python@gentoo.org> 7# Gentoo Python Project <python@gentoo.org>
8# @BLURB: Eclass for Python packages 8# @BLURB: Eclass for Python packages
13 13
14if ! has "${EAPI:-0}" 0 1 2 3; then 14if ! has "${EAPI:-0}" 0 1 2 3; then
15 die "API of python.eclass in EAPI=\"${EAPI}\" not established" 15 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16fi 16fi
17 17
18_CPYTHON2_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7) 18_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
19_CPYTHON3_SUPPORTED_ABIS=(3.0 3.1 3.2) 19_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.0 3.1 3.2 3.3)
20_JYTHON_SUPPORTED_ABIS=(2.5-jython) 20_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython)
21_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]})
22
23# ================================================================================================
24# ===================================== HANDLING OF METADATA =====================================
25# ================================================================================================
26
27_PYTHON_ABI_PATTERN_REGEX="([[:alnum:]]|\.|-|\*|\[|\])+"
28
29_python_check_python_abi_matching() {
30 local pattern patterns patterns_list="0" PYTHON_ABI
31
32 while (($#)); do
33 case "$1" in
34 --patterns-list)
35 patterns_list="1"
36 ;;
37 --)
38 shift
39 break
40 ;;
41 -*)
42 die "${FUNCNAME}(): Unrecognized option '$1'"
43 ;;
44 *)
45 break
46 ;;
47 esac
48 shift
49 done
50
51 if [[ "$#" -ne 2 ]]; then
52 die "${FUNCNAME}() requires 2 arguments"
53 fi
54
55 PYTHON_ABI="$1"
56
57 if [[ "${patterns_list}" == "0" ]]; then
58 pattern="$2"
59
60 if [[ "${pattern}" == *"-cpython" ]]; then
61 [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ && "${PYTHON_ABI}" == ${pattern%-cpython} ]]
62 elif [[ "${pattern}" == *"-jython" ]]; then
63 [[ "${PYTHON_ABI}" == ${pattern} ]]
64 else
65 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
66 [[ "${PYTHON_ABI}" == ${pattern} ]]
67 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
68 [[ "${PYTHON_ABI%-jython}" == ${pattern} ]]
69 else
70 die "${FUNCNAME}(): Unrecognized Python ABI '${PYTHON_ABI}'"
71 fi
72 fi
73 else
74 patterns="${2// /$'\n'}"
75
76 while read pattern; do
77 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
78 return 0
79 fi
80 done <<< "${patterns}"
81
82 return 1
83 fi
84}
85
86_python_package_supporting_installation_for_multiple_python_abis() {
87 if has "${EAPI:-0}" 0 1 2 3 4; then
88 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
89 return 0
90 else
91 return 1
92 fi
93 else
94 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
95 fi
96}
21 97
22# @ECLASS-VARIABLE: PYTHON_DEPEND 98# @ECLASS-VARIABLE: PYTHON_DEPEND
23# @DESCRIPTION: 99# @DESCRIPTION:
24# Specification of dependency on dev-lang/python. 100# Specification of dependency on dev-lang/python.
25# Syntax: 101# Syntax:
27# version_components_group: <major_version[:[minimal_version][:maximal_version]]> 103# version_components_group: <major_version[:[minimal_version][:maximal_version]]>
28# major_version: <2|3|*> 104# major_version: <2|3|*>
29# minimal_version: <minimal_major_version.minimal_minor_version> 105# minimal_version: <minimal_major_version.minimal_minor_version>
30# maximal_version: <maximal_major_version.maximal_minor_version> 106# maximal_version: <maximal_major_version.maximal_minor_version>
31 107
32_parse_PYTHON_DEPEND() { 108_python_parse_PYTHON_DEPEND() {
33 local major_version maximal_version minimal_version python_all="0" python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups 109 local major_version maximal_version minimal_version python_all="0" python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups
34 110
35 version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?" 111 version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?"
36 version_components_groups="${PYTHON_DEPEND}" 112 version_components_groups="${PYTHON_DEPEND}"
37 113
60 fi 136 fi
61 fi 137 fi
62 138
63 if [[ "${major_version}" == "2" ]]; then 139 if [[ "${major_version}" == "2" ]]; then
64 python2="1" 140 python2="1"
65 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}") 141 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}")
66 python2_minimal_version="${minimal_version}" 142 python2_minimal_version="${minimal_version}"
67 python2_maximal_version="${maximal_version}" 143 python2_maximal_version="${maximal_version}"
68 elif [[ "${major_version}" == "3" ]]; then 144 elif [[ "${major_version}" == "3" ]]; then
69 python3="1" 145 python3="1"
70 python_versions=("${_CPYTHON3_SUPPORTED_ABIS[@]}") 146 python_versions=("${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
71 python3_minimal_version="${minimal_version}" 147 python3_minimal_version="${minimal_version}"
72 python3_maximal_version="${maximal_version}" 148 python3_maximal_version="${maximal_version}"
73 else 149 else
74 python_all="1" 150 python_all="1"
75 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}") 151 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
76 python_minimal_version="${minimal_version}" 152 python_minimal_version="${minimal_version}"
77 python_maximal_version="${maximal_version}" 153 python_maximal_version="${maximal_version}"
78 fi 154 fi
79 155
80 if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then 156 if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then
108 184
109 if [[ "${python_all}" == "1" ]]; then 185 if [[ "${python_all}" == "1" ]]; then
110 if [[ -z "${python_minimal_version}" && -z "${python_maximal_version}" ]]; then 186 if [[ -z "${python_minimal_version}" && -z "${python_maximal_version}" ]]; then
111 _PYTHON_ATOMS+=("dev-lang/python") 187 _PYTHON_ATOMS+=("dev-lang/python")
112 else 188 else
113 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}") 189 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
114 python_minimal_version="${python_minimal_version:-${python_versions[0]}}" 190 python_minimal_version="${python_minimal_version:-${python_versions[0]}}"
115 python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 191 python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
116 _append_accepted_versions_range 192 _append_accepted_versions_range
117 fi 193 fi
118 else 194 else
119 if [[ "${python3}" == "1" ]]; then 195 if [[ "${python3}" == "1" ]]; then
120 if [[ -z "${python3_minimal_version}" && -z "${python3_maximal_version}" ]]; then 196 if [[ -z "${python3_minimal_version}" && -z "${python3_maximal_version}" ]]; then
121 _PYTHON_ATOMS+=("=dev-lang/python-3*") 197 _PYTHON_ATOMS+=("=dev-lang/python-3*")
122 else 198 else
123 python_versions=("${_CPYTHON3_SUPPORTED_ABIS[@]}") 199 python_versions=("${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
124 python_minimal_version="${python3_minimal_version:-${python_versions[0]}}" 200 python_minimal_version="${python3_minimal_version:-${python_versions[0]}}"
125 python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 201 python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
126 _append_accepted_versions_range 202 _append_accepted_versions_range
127 fi 203 fi
128 fi 204 fi
129 if [[ "${python2}" == "1" ]]; then 205 if [[ "${python2}" == "1" ]]; then
130 if [[ -z "${python2_minimal_version}" && -z "${python2_maximal_version}" ]]; then 206 if [[ -z "${python2_minimal_version}" && -z "${python2_maximal_version}" ]]; then
131 _PYTHON_ATOMS+=("=dev-lang/python-2*") 207 _PYTHON_ATOMS+=("=dev-lang/python-2*")
132 else 208 else
133 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}") 209 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}")
134 python_minimal_version="${python2_minimal_version:-${python_versions[0]}}" 210 python_minimal_version="${python2_minimal_version:-${python_versions[0]}}"
135 python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}" 211 python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
136 _append_accepted_versions_range 212 _append_accepted_versions_range
137 fi 213 fi
138 fi 214 fi
153} 229}
154 230
155DEPEND=">=app-admin/eselect-python-20091230" 231DEPEND=">=app-admin/eselect-python-20091230"
156RDEPEND="${DEPEND}" 232RDEPEND="${DEPEND}"
157 233
158if [[ -n "${PYTHON_DEPEND}" && -n "${NEED_PYTHON}" ]]; then
159 die "PYTHON_DEPEND and NEED_PYTHON cannot be set simultaneously"
160elif [[ -n "${PYTHON_DEPEND}" ]]; then 234if [[ -n "${PYTHON_DEPEND}" ]]; then
161 _parse_PYTHON_DEPEND 235 _python_parse_PYTHON_DEPEND
162elif [[ -n "${NEED_PYTHON}" ]]; then
163 if ! has "${EAPI:-0}" 0 1 2; then
164 eerror "Use PYTHON_DEPEND instead of NEED_PYTHON."
165 die "NEED_PYTHON cannot be used in this EAPI"
166 fi
167 _PYTHON_ATOMS=(">=dev-lang/python-${NEED_PYTHON}")
168 DEPEND+="${DEPEND:+ }${_PYTHON_ATOMS[@]}"
169 RDEPEND+="${RDEPEND:+ }${_PYTHON_ATOMS[@]}"
170else 236else
171 _PYTHON_ATOMS=("dev-lang/python") 237 _PYTHON_ATOMS=("dev-lang/python")
238fi
239unset -f _python_parse_PYTHON_DEPEND
240
241if [[ -n "${NEED_PYTHON}" ]]; then
242 eerror "Use PYTHON_DEPEND variable instead of NEED_PYTHON variable."
243 die "NEED_PYTHON variable is banned"
172fi 244fi
173 245
174# @ECLASS-VARIABLE: PYTHON_USE_WITH 246# @ECLASS-VARIABLE: PYTHON_USE_WITH
175# @DESCRIPTION: 247# @DESCRIPTION:
176# Set this to a space separated list of USE flags the Python slot in use must be built with. 248# Set this to a space separated list of USE flags the Python slot in use must be built with.
225 else 297 else
226 return 1 298 return 1
227 fi 299 fi
228} 300}
229 301
230_python_package_supporting_installation_for_multiple_python_abis() { 302_python_abi-specific_local_scope() {
231 if [[ "${EBUILD_PHASE}" == "depend" ]]; then 303 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]]
232 die "${FUNCNAME}() cannot be used in global scope"
233 fi
234
235 if has "${EAPI:-0}" 0 1 2 3 4; then
236 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
237 return 0
238 else
239 return 1
240 fi
241 else
242 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
243 fi
244} 304}
245 305
246_python_initialize_prefix_variables() { 306_python_initialize_prefix_variables() {
247 if has "${EAPI:-0}" 0 1 2; then 307 if has "${EAPI:-0}" 0 1 2; then
248 if [[ -n "${ROOT}" && -z "${EROOT}" ]]; then 308 if [[ -n "${ROOT}" && -z "${EROOT}" ]]; then
252 ED="${D%/}${EPREFIX}/" 312 ED="${D%/}${EPREFIX}/"
253 fi 313 fi
254 fi 314 fi
255} 315}
256 316
257unset PYTHON_SANITY_CHECKS 317unset PYTHON_SANITY_CHECKS_EXECUTED PYTHON_SKIP_SANITY_CHECKS
258 318
259_python_initial_sanity_checks() { 319_python_initial_sanity_checks() {
260 if [[ "$(declare -p PYTHON_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS="* ]]; then 320 if [[ "$(declare -p PYTHON_SANITY_CHECKS_EXECUTED 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS_EXECUTED="* || " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " && -z "${PYTHON_SKIP_SANITY_CHECKS}" ]]; then
261 # Ensure that /usr/bin/python and /usr/bin/python-config are valid. 321 # Ensure that /usr/bin/python and /usr/bin/python-config are valid.
262 if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then 322 if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then
263 eerror "'${EPREFIX}/usr/bin/python' is not valid symlink." 323 eerror "'${EPREFIX}/usr/bin/python' is not valid symlink."
264 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem." 324 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
265 die "'${EPREFIX}/usr/bin/python' is not valid symlink" 325 die "'${EPREFIX}/usr/bin/python' is not valid symlink"
271 fi 331 fi
272 fi 332 fi
273} 333}
274 334
275_python_final_sanity_checks() { 335_python_final_sanity_checks() {
276 if ! _python_implementation && [[ "$(declare -p PYTHON_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS="* ]]; then 336 if ! _python_implementation && [[ "$(declare -p PYTHON_SANITY_CHECKS_EXECUTED 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS_EXECUTED="* || " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " && -z "${PYTHON_SKIP_SANITY_CHECKS}" ]]; then
277 local PYTHON_ABI="${PYTHON_ABI}" 337 local PYTHON_ABI="${PYTHON_ABI}"
278 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI}}; do 338 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI}}; do
279 # Ensure that appropriate version of Python is installed. 339 # Ensure that appropriate version of Python is installed.
280 if ! has_version "$(python_get_implementational_package)"; then 340 if ! has_version "$(python_get_implementational_package)"; then
281 die "$(python_get_implementational_package) is not installed" 341 die "$(python_get_implementational_package) is not installed"
291 eerror "Locally active version of Python: '$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")'" 351 eerror "Locally active version of Python: '$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")'"
292 die "'python' does not respect EPYTHON variable" 352 die "'python' does not respect EPYTHON variable"
293 fi 353 fi
294 done 354 done
295 fi 355 fi
296 PYTHON_SANITY_CHECKS="1" 356 PYTHON_SANITY_CHECKS_EXECUTED="1"
297} 357}
358
359# @ECLASS-VARIABLE: PYTHON_COLORS
360# @DESCRIPTION:
361# User-configurable colored output.
362PYTHON_COLORS="${PYTHON_COLORS:-0}"
298 363
299_python_set_color_variables() { 364_python_set_color_variables() {
300 if [[ "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then 365 if [[ "${PYTHON_COLORS}" != "0" && "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
301 _BOLD=$'\e[1m' 366 _BOLD=$'\e[1m'
302 _RED=$'\e[1;31m' 367 _RED=$'\e[1;31m'
303 _GREEN=$'\e[1;32m' 368 _GREEN=$'\e[1;32m'
304 _BLUE=$'\e[1;34m' 369 _BLUE=$'\e[1;34m'
305 _CYAN=$'\e[1;36m' 370 _CYAN=$'\e[1;36m'
314 fi 379 fi
315} 380}
316 381
317unset PYTHON_PKG_SETUP_EXECUTED 382unset PYTHON_PKG_SETUP_EXECUTED
318 383
384_python_check_python_pkg_setup_execution() {
385 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return
386
387 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then
388 die "python_pkg_setup() not called"
389 fi
390}
391
319# @FUNCTION: python_pkg_setup 392# @FUNCTION: python_pkg_setup
320# @DESCRIPTION: 393# @DESCRIPTION:
321# Perform sanity checks and initialize environment. 394# Perform sanity checks and initialize environment.
322# 395#
323# This function is exported in EAPI 2 and 3 when PYTHON_USE_WITH or PYTHON_USE_WITH_OR variable 396# This function is exported in EAPI 2 and 3 when PYTHON_USE_WITH or PYTHON_USE_WITH_OR variable
324# is set and always in EAPI >=4. Calling of this function is mandatory in EAPI >=4. 397# is set and always in EAPI >=4. Calling of this function is mandatory in EAPI >=4.
325#
326# This function can be used only in pkg_setup() phase.
327python_pkg_setup() { 398python_pkg_setup() {
328 # Check if phase is pkg_setup(). 399 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
329 [[ "${EBUILD_PHASE}" != "setup" ]] && die "${FUNCNAME}() can be used only in pkg_setup() phase" 400 die "${FUNCNAME}() can be used only in pkg_setup() phase"
401 fi
402
403 if [[ "$#" -ne 0 ]]; then
404 die "${FUNCNAME}() does not accept arguments"
405 fi
406
407 export JYTHON_SYSTEM_CACHEDIR="1"
408 addwrite "${EPREFIX}/var/cache/jython"
330 409
331 if _python_package_supporting_installation_for_multiple_python_abis; then 410 if _python_package_supporting_installation_for_multiple_python_abis; then
332 _python_calculate_PYTHON_ABIS 411 _python_calculate_PYTHON_ABIS
333 export EPYTHON="$(PYTHON -f)" 412 export EPYTHON="$(PYTHON -f)"
334 else 413 else
366 die "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}" 445 die "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
367 fi 446 fi
368 } 447 }
369 448
370 if _python_package_supporting_installation_for_multiple_python_abis; then 449 if _python_package_supporting_installation_for_multiple_python_abis; then
371 python_execute_function -q python_pkg_setup_check_USE_flags 450 PYTHON_SKIP_SANITY_CHECKS="1" python_execute_function -q python_pkg_setup_check_USE_flags
372 else 451 else
373 python_pkg_setup_check_USE_flags 452 python_pkg_setup_check_USE_flags
374 fi 453 fi
375 454
376 unset -f python_pkg_setup_check_USE_flags 455 unset -f python_pkg_setup_check_USE_flags
377 fi 456 fi
378 457
379 PYTHON_PKG_SETUP_EXECUTED="1" 458 PYTHON_PKG_SETUP_EXECUTED="1"
380} 459}
381 460
382if ! has "${EAPI:-0}" 0 1 2 3 || has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; then 461if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
383 EXPORT_FUNCTIONS pkg_setup 462 EXPORT_FUNCTIONS pkg_setup
384fi 463fi
385 464
465_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|python)'
466
386# @FUNCTION: python_convert_shebangs 467# @FUNCTION: python_convert_shebangs
387# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_version> <file|directory> [files|directories] 468# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories]
388# @DESCRIPTION: 469# @DESCRIPTION:
389# Convert shebangs in specified files. Directories can be specified only with --recursive option. 470# Convert shebangs in specified files. Directories can be specified only with --recursive option.
390python_convert_shebangs() { 471python_convert_shebangs() {
472 _python_check_python_pkg_setup_execution
473
391 local argument file files=() only_executables="0" python_version quiet="0" recursive="0" 474 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0"
392 475
393 while (($#)); do 476 while (($#)); do
394 case "$1" in 477 case "$1" in
395 -r|--recursive) 478 -r|--recursive)
396 recursive="1" 479 recursive="1"
419 die "${FUNCNAME}(): Missing Python version and files or directories" 502 die "${FUNCNAME}(): Missing Python version and files or directories"
420 elif [[ "$#" -eq 1 ]]; then 503 elif [[ "$#" -eq 1 ]]; then
421 die "${FUNCNAME}(): Missing files or directories" 504 die "${FUNCNAME}(): Missing files or directories"
422 fi 505 fi
423 506
424 python_version="$1" 507 if [[ -n "$(_python_get_implementation --ignore-invalid "$1")" ]]; then
508 python_interpreter="$(PYTHON "$1")"
509 else
510 python_interpreter="python$1"
511 fi
425 shift 512 shift
426 513
427 for argument in "$@"; do 514 for argument in "$@"; do
428 if [[ ! -e "${argument}" ]]; then 515 if [[ ! -e "${argument}" ]]; then
429 die "${FUNCNAME}(): '${argument}' does not exist" 516 die "${FUNCNAME}(): '${argument}' does not exist"
444 531
445 for file in "${files[@]}"; do 532 for file in "${files[@]}"; do
446 file="${file#./}" 533 file="${file#./}"
447 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue 534 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
448 535
449 if [[ "$(head -n1 "${file}")" =~ ^'#!'.*python ]]; then 536 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then
450 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue 537 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
451 538
452 if [[ "${quiet}" == "0" ]]; then 539 if [[ "${quiet}" == "0" ]]; then
453 einfo "Converting shebang in '${file}'" 540 einfo "Converting shebang in '${file}'"
454 fi 541 fi
455 542
456 sed -e "1s/python\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?/python${python_version}/" -i "${file}" || die "Conversion of shebang in '${file}' failed" 543 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
457
458 # Delete potential whitespace after "#!".
459 sed -e '1s/\(^#!\)[[:space:]]*/\1/' -i "${file}" || die "sed '${file}' failed"
460 fi 544 fi
461 done 545 done
462} 546}
463 547
464# @FUNCTION: python_clean_installation_image 548# @FUNCTION: python_clean_installation_image
465# @USAGE: [-q|--quiet] 549# @USAGE: [-q|--quiet]
466# @DESCRIPTION: 550# @DESCRIPTION:
467# Delete needless files in installation image. 551# Delete needless files in installation image.
552#
553# This function can be used only in src_install() phase.
468python_clean_installation_image() { 554python_clean_installation_image() {
555 if [[ "${EBUILD_PHASE}" != "install" ]]; then
556 die "${FUNCNAME}() can be used only in src_install() phase"
557 fi
558
559 _python_check_python_pkg_setup_execution
469 _python_initialize_prefix_variables 560 _python_initialize_prefix_variables
470 561
471 local file files=() quiet="0" 562 local file files=() quiet="0"
472
473 # Check if phase is src_install().
474 [[ "${EBUILD_PHASE}" != "install" ]] && die "${FUNCNAME}() can be used only in src_install() phase"
475 563
476 while (($#)); do 564 while (($#)); do
477 case "$1" in 565 case "$1" in
478 -q|--quiet) 566 -q|--quiet)
479 quiet="1" 567 quiet="1"
530# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS 618# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS
531# @DESCRIPTION: 619# @DESCRIPTION:
532# Set this in EAPI <= 4 to indicate that current package supports installation for 620# Set this in EAPI <= 4 to indicate that current package supports installation for
533# multiple Python ABIs. 621# multiple Python ABIs.
534 622
623# @ECLASS-VARIABLE: PYTHON_TESTS_RESTRICTED_ABIS
624# @DESCRIPTION:
625# Space-separated list of Python ABI patterns. Testing in Python ABIs matching any Python ABI
626# patterns specified in this list is skipped.
627
535# @ECLASS-VARIABLE: PYTHON_EXPORT_PHASE_FUNCTIONS 628# @ECLASS-VARIABLE: PYTHON_EXPORT_PHASE_FUNCTIONS
536# @DESCRIPTION: 629# @DESCRIPTION:
537# Set this to export phase functions for the following ebuild phases: 630# Set this to export phase functions for the following ebuild phases:
538# src_prepare, src_configure, src_compile, src_test, src_install. 631# src_prepare(), src_configure(), src_compile(), src_test(), src_install().
539if ! has "${EAPI:-0}" 0 1; then 632if ! has "${EAPI:-0}" 0 1; then
540 python_src_prepare() { 633 python_src_prepare() {
634 if [[ "${EBUILD_PHASE}" != "prepare" ]]; then
635 die "${FUNCNAME}() can be used only in src_prepare() phase"
636 fi
637
541 if ! _python_package_supporting_installation_for_multiple_python_abis; then 638 if ! _python_package_supporting_installation_for_multiple_python_abis; then
542 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 639 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
543 fi 640 fi
544 641
642 _python_check_python_pkg_setup_execution
643
644 if [[ "$#" -ne 0 ]]; then
645 die "${FUNCNAME}() does not accept arguments"
646 fi
647
545 python_copy_sources 648 python_copy_sources
546 } 649 }
547 650
548 for python_default_function in src_configure src_compile src_test src_install; do 651 for python_default_function in src_configure src_compile src_test; do
549 eval "python_${python_default_function}() { 652 eval "python_${python_default_function}() {
653 if [[ \"\${EBUILD_PHASE}\" != \"${python_default_function#src_}\" ]]; then
654 die \"\${FUNCNAME}() can be used only in ${python_default_function}() phase\"
655 fi
656
550 if ! _python_package_supporting_installation_for_multiple_python_abis; then 657 if ! _python_package_supporting_installation_for_multiple_python_abis; then
551 die \"\${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs\" 658 die \"\${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs\"
552 fi 659 fi
553 660
661 _python_check_python_pkg_setup_execution
662
554 python_execute_function -d -s -- \"\$@\" 663 python_execute_function -d -s -- \"\$@\"
555 }" 664 }"
556 done 665 done
557 unset python_default_function 666 unset python_default_function
558 667
668 python_src_install() {
669 if [[ "${EBUILD_PHASE}" != "install" ]]; then
670 die "${FUNCNAME}() can be used only in src_install() phase"
671 fi
672
673 if ! _python_package_supporting_installation_for_multiple_python_abis; then
674 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
675 fi
676
677 _python_check_python_pkg_setup_execution
678
679 if has "${EAPI:-0}" 0 1 2 3; then
680 python_execute_function -d -s -- "$@"
681 else
682 python_installation() {
683 emake DESTDIR="${T}/images/${PYTHON_ABI}" install "$@"
684 }
685 python_execute_function -s python_installation "$@"
686 unset python_installation
687
688 python_merge_intermediate_installation_images "${T}/images"
689 fi
690 }
691
559 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then 692 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then
560 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install 693 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install
561 fi 694 fi
562fi 695fi
563 696
697if has "${EAPI:-0}" 0 1 2 3 4; then
564unset PYTHON_ABIS 698 unset PYTHON_ABIS
699fi
565 700
566_python_calculate_PYTHON_ABIS() { 701_python_calculate_PYTHON_ABIS() {
567 if ! _python_package_supporting_installation_for_multiple_python_abis; then 702 if ! _python_package_supporting_installation_for_multiple_python_abis; then
568 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 703 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
569 fi 704 fi
570 705
571 _python_initial_sanity_checks 706 _python_initial_sanity_checks
572 707
573 # USE_${ABI_TYPE^^} and RESTRICT_${ABI_TYPE^^}_ABIS variables hopefully will be included in EAPI >= 5.
574 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then 708 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then
575 local PYTHON_ABI restricted_ABI support_ABI supported_PYTHON_ABIS= 709 local PYTHON_ABI
576 PYTHON_ABI_SUPPORTED_VALUES="${_CPYTHON2_SUPPORTED_ABIS[@]} ${_CPYTHON3_SUPPORTED_ABIS[@]} ${_JYTHON_SUPPORTED_ABIS[@]}"
577 710
578 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then 711 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
579 local cpython_enabled="0" 712 local cpython_enabled="0"
580 713
581 if [[ -z "${USE_PYTHON}" ]]; then 714 if [[ -z "${USE_PYTHON}" ]]; then
582 die "USE_PYTHON variable is empty" 715 die "USE_PYTHON variable is empty"
583 fi 716 fi
584 717
585 for PYTHON_ABI in ${USE_PYTHON}; do 718 for PYTHON_ABI in ${USE_PYTHON}; do
586 if ! has "${PYTHON_ABI}" ${PYTHON_ABI_SUPPORTED_VALUES}; then 719 if ! has "${PYTHON_ABI}" "${_PYTHON_GLOBALLY_SUPPORTED_ABIS[@]}"; then
587 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'" 720 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'"
588 fi 721 fi
589 722
590 if has "${PYTHON_ABI}" "${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}"; then 723 if has "${PYTHON_ABI}" "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; then
591 cpython_enabled="1" 724 cpython_enabled="1"
592 fi 725 fi
593 726
594 support_ABI="1" 727 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
595 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 728 export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
596 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then 729 fi
597 support_ABI="0" 730 done
731
732 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
733 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}"
734 fi
735
736 if [[ "${cpython_enabled}" == "0" ]]; then
737 die "USE_PYTHON variable does not enable any CPython ABI"
738 fi
739 else
740 local python_version python2_version python3_version support_python_major_version
741
742 if ! has_version "dev-lang/python"; then
743 die "${FUNCNAME}(): 'dev-lang/python' is not installed"
744 fi
745
746 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
747
748 if has_version "=dev-lang/python-2*"; then
749 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then
750 die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
751 fi
752
753 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
754
755 support_python_major_version="0"
756 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
757 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
758 support_python_major_version="1"
598 break 759 break
599 fi 760 fi
600 done 761 done
601 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
602 done
603
604 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
605 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}"
606 fi
607
608 if [[ "${cpython_enabled}" == "0" ]]; then
609 die "USE_PYTHON variable does not enable any CPython ABI"
610 fi
611 else
612 local python_version python2_version= python3_version= support_python_major_version
613
614 if ! has_version "dev-lang/python"; then
615 die "${FUNCNAME}(): 'dev-lang/python' is not installed"
616 fi
617
618 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
619
620 if has_version "=dev-lang/python-2*"; then
621 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then
622 die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
623 fi
624
625 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
626
627 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do
628 support_python_major_version="1"
629 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
630 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
631 support_python_major_version="0"
632 fi
633 done
634 [[ "${support_python_major_version}" == "1" ]] && break
635 done
636 if [[ "${support_python_major_version}" == "1" ]]; then 762 if [[ "${support_python_major_version}" == "1" ]]; then
637 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 763 if _python_check_python_abi_matching --patterns-list "${python2_version}" "${RESTRICT_PYTHON_ABIS}"; then
638 if [[ "${python2_version}" == ${restricted_ABI} ]]; then
639 die "Active version of Python 2 is not supported by ${CATEGORY}/${PF}" 764 die "Active version of CPython 2 is not supported by ${CATEGORY}/${PF}"
640 fi 765 fi
641 done
642 else 766 else
643 python2_version="" 767 python2_version=""
644 fi 768 fi
645 fi 769 fi
646 770
649 die "'${EPREFIX}/usr/bin/python3' is not valid symlink" 773 die "'${EPREFIX}/usr/bin/python3' is not valid symlink"
650 fi 774 fi
651 775
652 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')" 776 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
653 777
778 support_python_major_version="0"
654 for PYTHON_ABI in "${_CPYTHON3_SUPPORTED_ABIS[@]}"; do 779 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
780 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
655 support_python_major_version="1" 781 support_python_major_version="1"
656 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 782 break
657 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
658 support_python_major_version="0"
659 fi 783 fi
660 done
661 [[ "${support_python_major_version}" == "1" ]] && break
662 done 784 done
663 if [[ "${support_python_major_version}" == "1" ]]; then 785 if [[ "${support_python_major_version}" == "1" ]]; then
664 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 786 if _python_check_python_abi_matching --patterns-list "${python3_version}" "${RESTRICT_PYTHON_ABIS}"; then
665 if [[ "${python3_version}" == ${restricted_ABI} ]]; then
666 die "Active version of Python 3 is not supported by ${CATEGORY}/${PF}" 787 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}"
667 fi 788 fi
668 done
669 else 789 else
670 python3_version="" 790 python3_version=""
671 fi 791 fi
672 fi 792 fi
673 793
687 export PYTHON_ABIS="${PYTHON_ABIS% }" 807 export PYTHON_ABIS="${PYTHON_ABIS% }"
688 fi 808 fi
689 fi 809 fi
690 810
691 _python_final_sanity_checks 811 _python_final_sanity_checks
812}
813
814_python_prepare_flags() {
815 local array=() deleted_flag element flags new_value old_flag old_value operator pattern prefix variable
816
817 for variable in CPPFLAGS CFLAGS CXXFLAGS LDFLAGS; do
818 eval "_PYTHON_SAVED_${variable}=\"\${!variable}\""
819 for prefix in PYTHON_USER_ PYTHON_; do
820 if [[ "$(declare -p ${prefix}${variable} 2> /dev/null)" == "declare -a ${prefix}${variable}="* ]]; then
821 eval "array=(\"\${${prefix}${variable}[@]}\")"
822 for element in "${array[@]}"; do
823 if [[ "${element}" =~ ^${_PYTHON_ABI_PATTERN_REGEX}\ (\+|-)\ .+ ]]; then
824 pattern="${element%% *}"
825 element="${element#* }"
826 operator="${element%% *}"
827 flags="${element#* }"
828 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
829 if [[ "${operator}" == "+" ]]; then
830 eval "export ${variable}+=\"\${variable:+ }${flags}\""
831 elif [[ "${operator}" == "-" ]]; then
832 flags="${flags// /$'\n'}"
833 old_value="${!variable// /$'\n'}"
834 new_value=""
835 while read old_flag; do
836 while read deleted_flag; do
837 if [[ "${old_flag}" == ${deleted_flag} ]]; then
838 continue 2
839 fi
840 done <<< "${flags}"
841 new_value+="${new_value:+ }${old_flag}"
842 done <<< "${old_value}"
843 eval "export ${variable}=\"\${new_value}\""
844 fi
845 fi
846 else
847 die "Element '${element}' of ${prefix}${variable} array has invalid syntax"
848 fi
849 done
850 elif [[ -n "$(declare -p ${prefix}${variable} 2> /dev/null)" ]]; then
851 die "${prefix}${variable} should be indexed array"
852 fi
853 done
854 done
855}
856
857_python_restore_flags() {
858 local variable
859
860 for variable in CPPFLAGS CFLAGS CXXFLAGS LDFLAGS; do
861 eval "${variable}=\"\${_PYTHON_SAVED_${variable}}\""
862 unset _PYTHON_SAVED_${variable}
863 done
692} 864}
693 865
694# @FUNCTION: python_execute_function 866# @FUNCTION: python_execute_function
695# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments] 867# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments]
696# @DESCRIPTION: 868# @DESCRIPTION:
699python_execute_function() { 871python_execute_function() {
700 if ! _python_package_supporting_installation_for_multiple_python_abis; then 872 if ! _python_package_supporting_installation_for_multiple_python_abis; then
701 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 873 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
702 fi 874 fi
703 875
876 _python_check_python_pkg_setup_execution
704 _python_set_color_variables 877 _python_set_color_variables
705 878
706 local action action_message action_message_template= default_function="0" failure_message failure_message_template= final_ABI="0" function i iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" separate_build_dirs="0" source_dir= 879 local action action_message action_message_template default_function="0" failure_message failure_message_template final_ABI="0" function iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" return_code separate_build_dirs="0" source_dir
707 880
708 while (($#)); do 881 while (($#)); do
709 case "$1" in 882 case "$1" in
710 --action-message) 883 --action-message)
711 action_message_template="$2" 884 action_message_template="$2"
798 fi 971 fi
799 function="python_default_function" 972 function="python_default_function"
800 fi 973 fi
801 974
802 # Ensure that python_execute_function() cannot be directly or indirectly called by python_execute_function(). 975 # Ensure that python_execute_function() cannot be directly or indirectly called by python_execute_function().
803 for ((i = 1; i < "${#FUNCNAME[@]}"; i++)); do 976 if _python_abi-specific_local_scope; then
804 if [[ "${FUNCNAME[${i}]}" == "${FUNCNAME}" ]]; then
805 die "${FUNCNAME}(): Invalid call stack" 977 die "${FUNCNAME}(): Invalid call stack"
806 fi 978 fi
807 done
808 979
809 if [[ "${quiet}" == "0" ]]; then 980 if [[ "${quiet}" == "0" ]]; then
810 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up" 981 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up"
811 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking" 982 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking"
812 [[ "${EBUILD_PHASE}" == "prepare" ]] && action="Preparation" 983 [[ "${EBUILD_PHASE}" == "prepare" ]] && action="Preparation"
825 iterated_PYTHON_ABIS="$(PYTHON -f --ABI)" 996 iterated_PYTHON_ABIS="$(PYTHON -f --ABI)"
826 else 997 else
827 iterated_PYTHON_ABIS="${PYTHON_ABIS}" 998 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
828 fi 999 fi
829 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 1000 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
1001 if [[ "${EBUILD_PHASE}" == "test" ]] && _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${PYTHON_TESTS_RESTRICTED_ABIS}"; then
1002 if [[ "${quiet}" == "0" ]]; then
1003 echo " ${_GREEN}*${_NORMAL} ${_BLUE}Testing of ${CATEGORY}/${PF} with $(python_get_implementation_and_version) skipped${_NORMAL}"
1004 fi
1005 continue
1006 fi
1007
1008 _python_prepare_flags
1009
830 if [[ "${quiet}" == "0" ]]; then 1010 if [[ "${quiet}" == "0" ]]; then
831 if [[ -n "${action_message_template}" ]]; then 1011 if [[ -n "${action_message_template}" ]]; then
832 action_message="$(eval echo -n "${action_message_template}")" 1012 eval "action_message=\"${action_message_template}\""
833 else 1013 else
834 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version)..." 1014 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation_and_version)..."
835 fi 1015 fi
836 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}" 1016 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}"
837 fi 1017 fi
838 1018
839 if [[ "${separate_build_dirs}" == "1" ]]; then 1019 if [[ "${separate_build_dirs}" == "1" ]]; then
855 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@" 1035 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@"
856 else 1036 else
857 EPYTHON="$(PYTHON)" "${function}" "$@" 1037 EPYTHON="$(PYTHON)" "${function}" "$@"
858 fi 1038 fi
859 1039
860 if [[ "$?" != "0" ]]; then 1040 return_code="$?"
1041
1042 _python_restore_flags
1043
1044 if [[ "${return_code}" -ne 0 ]]; then
861 if [[ -n "${failure_message_template}" ]]; then 1045 if [[ -n "${failure_message_template}" ]]; then
862 failure_message="$(eval echo -n "${failure_message_template}")" 1046 eval "failure_message=\"${failure_message_template}\""
863 else 1047 else
864 failure_message="${action} failed with $(python_get_implementation) $(python_get_version) in ${function}() function" 1048 failure_message="${action} failed with $(python_get_implementation_and_version) in ${function}() function"
865 fi 1049 fi
866 1050
867 if [[ "${nonfatal}" == "1" ]]; then 1051 if [[ "${nonfatal}" == "1" ]]; then
868 if [[ "${quiet}" == "0" ]]; then 1052 if [[ "${quiet}" == "0" ]]; then
869 ewarn "${_RED}${failure_message}${_NORMAL}" 1053 ewarn "${failure_message}"
870 fi 1054 fi
871 elif [[ "${final_ABI}" == "0" ]] && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then 1055 elif [[ "${final_ABI}" == "0" ]] && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
872 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then 1056 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then
873 local enabled_PYTHON_ABIS= other_PYTHON_ABI 1057 local enabled_PYTHON_ABIS= other_PYTHON_ABI
874 for other_PYTHON_ABI in ${PYTHON_ABIS}; do 1058 for other_PYTHON_ABI in ${PYTHON_ABIS}; do
875 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}" 1059 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}"
876 done 1060 done
877 export PYTHON_ABIS="${enabled_PYTHON_ABIS}" 1061 export PYTHON_ABIS="${enabled_PYTHON_ABIS}"
878 fi 1062 fi
879 if [[ "${quiet}" == "0" ]]; then 1063 if [[ "${quiet}" == "0" ]]; then
880 ewarn "${_RED}${failure_message}${_NORMAL}" 1064 ewarn "${failure_message}"
881 fi 1065 fi
882 if [[ -z "${PYTHON_ABIS}" ]]; then 1066 if [[ -z "${PYTHON_ABIS}" ]]; then
883 die "${function}() function failed with all enabled Python ABIs" 1067 die "${function}() function failed with all enabled Python ABIs"
884 fi 1068 fi
885 else 1069 else
926python_copy_sources() { 1110python_copy_sources() {
927 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1111 if ! _python_package_supporting_installation_for_multiple_python_abis; then
928 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1112 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
929 fi 1113 fi
930 1114
1115 _python_check_python_pkg_setup_execution
1116
931 local dir dirs=() PYTHON_ABI 1117 local dir dirs=() PYTHON_ABI
932 1118
933 if [[ "$#" -eq 0 ]]; then 1119 if [[ "$#" -eq 0 ]]; then
934 if [[ "${WORKDIR}" == "${S}" ]]; then 1120 if [[ "${WORKDIR}" == "${S}" ]]; then
935 die "${FUNCNAME}() cannot be used with current value of S variable" 1121 die "${FUNCNAME}() cannot be used with current value of S variable"
951# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files] 1137# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files]
952# @DESCRIPTION: 1138# @DESCRIPTION:
953# Generate wrapper scripts. Existing files are overwritten only with --force option. 1139# Generate wrapper scripts. Existing files are overwritten only with --force option.
954# If --respect-EPYTHON option is specified, then generated wrapper scripts will 1140# If --respect-EPYTHON option is specified, then generated wrapper scripts will
955# respect EPYTHON variable at run time. 1141# respect EPYTHON variable at run time.
1142#
1143# This function can be used only in src_install() phase.
956python_generate_wrapper_scripts() { 1144python_generate_wrapper_scripts() {
1145 if [[ "${EBUILD_PHASE}" != "install" ]]; then
1146 die "${FUNCNAME}() can be used only in src_install() phase"
1147 fi
1148
957 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1149 if ! _python_package_supporting_installation_for_multiple_python_abis; then
958 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1150 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
959 fi 1151 fi
960 1152
1153 _python_check_python_pkg_setup_execution
961 _python_initialize_prefix_variables 1154 _python_initialize_prefix_variables
962 1155
963 local eselect_python_option file force="0" quiet="0" PYTHON_ABI python2_enabled="0" python3_enabled="0" respect_EPYTHON="0" 1156 local eselect_python_option file force="0" quiet="0" PYTHON_ABI PYTHON_ABIS_list python2_enabled="0" python3_enabled="0" respect_EPYTHON="0"
964 1157
965 while (($#)); do 1158 while (($#)); do
966 case "$1" in 1159 case "$1" in
967 -E|--respect-EPYTHON) 1160 -E|--respect-EPYTHON)
968 respect_EPYTHON="1" 1161 respect_EPYTHON="1"
990 if [[ "$#" -eq 0 ]]; then 1183 if [[ "$#" -eq 0 ]]; then
991 die "${FUNCNAME}(): Missing arguments" 1184 die "${FUNCNAME}(): Missing arguments"
992 fi 1185 fi
993 1186
994 _python_calculate_PYTHON_ABIS 1187 _python_calculate_PYTHON_ABIS
995 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do 1188 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
996 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then 1189 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
997 python2_enabled="1" 1190 python2_enabled="1"
998 fi 1191 fi
999 done 1192 done
1000 for PYTHON_ABI in "${_CPYTHON3_SUPPORTED_ABIS[@]}"; do 1193 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
1001 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then 1194 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
1002 python3_enabled="1" 1195 python3_enabled="1"
1003 fi 1196 fi
1004 done 1197 done
1005 1198
1011 eselect_python_option="--python3" 1204 eselect_python_option="--python3"
1012 else 1205 else
1013 die "${FUNCNAME}(): Unsupported environment" 1206 die "${FUNCNAME}(): Unsupported environment"
1014 fi 1207 fi
1015 1208
1209 PYTHON_ABIS_list="$("$(PYTHON -f)" -c "print(', '.join('\"%s\"' % x for x in reversed('${PYTHON_ABIS}'.split())))")"
1210
1016 for file in "$@"; do 1211 for file in "$@"; do
1017 if [[ -f "${file}" && "${force}" == "0" ]]; then 1212 if [[ -f "${file}" && "${force}" == "0" ]]; then
1018 die "${FUNCNAME}(): '$1' already exists" 1213 die "${FUNCNAME}(): '${file}' already exists"
1019 fi 1214 fi
1020 1215
1021 if [[ "${quiet}" == "0" ]]; then 1216 if [[ "${quiet}" == "0" ]]; then
1022 einfo "Generating '${file#${ED%/}}' wrapper script" 1217 einfo "Generating '${file#${ED%/}}' wrapper script"
1023 fi 1218 fi
1029import os 1224import os
1030import re 1225import re
1031import subprocess 1226import subprocess
1032import sys 1227import sys
1033 1228
1034EPYTHON_re = re.compile(r"^python(\d+\.\d+)$") 1229cpython_re = re.compile(r"^python(\d+\.\d+)$")
1230jython_re = re.compile(r"^jython(\d+\.\d+)$")
1035python_shebang_re = re.compile(r"^#! *(${EPREFIX}/usr/bin/python|(${EPREFIX})?/usr/bin/env +(${EPREFIX}/usr/bin/)?python)") 1231python_shebang_re = re.compile(r"^#! *(${EPREFIX}/usr/bin/python|(${EPREFIX})?/usr/bin/env +(${EPREFIX}/usr/bin/)?python)")
1036python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$") 1232python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
1233
1234def get_PYTHON_ABI(EPYTHON):
1235 cpython_matched = cpython_re.match(EPYTHON)
1236 jython_matched = jython_re.match(EPYTHON)
1237 if cpython_matched is not None:
1238 PYTHON_ABI = cpython_matched.group(1)
1239 elif jython_matched is not None:
1240 PYTHON_ABI = jython_matched.group(1) + "-jython"
1241 else:
1242 PYTHON_ABI = None
1243 return PYTHON_ABI
1037 1244
1038EOF 1245EOF
1039 if [[ "$?" != "0" ]]; then 1246 if [[ "$?" != "0" ]]; then
1040 die "${FUNCNAME}(): Generation of '$1' failed" 1247 die "${FUNCNAME}(): Generation of '$1' failed"
1041 fi 1248 fi
1042 if [[ "${respect_EPYTHON}" == "1" ]]; then 1249 if [[ "${respect_EPYTHON}" == "1" ]]; then
1043 cat << EOF >> "${file}" 1250 cat << EOF >> "${file}"
1044EPYTHON = os.environ.get("EPYTHON") 1251EPYTHON = os.environ.get("EPYTHON")
1045if EPYTHON: 1252if EPYTHON:
1046 EPYTHON_matched = EPYTHON_re.match(EPYTHON) 1253 PYTHON_ABI = get_PYTHON_ABI(EPYTHON)
1047 if EPYTHON_matched: 1254 if PYTHON_ABI is None:
1048 PYTHON_ABI = EPYTHON_matched.group(1)
1049 else:
1050 sys.stderr.write("EPYTHON variable has unrecognized value '%s'\n" % EPYTHON) 1255 sys.stderr.write("%s: EPYTHON variable has unrecognized value '%s'\n" % (sys.argv[0], EPYTHON))
1051 sys.exit(1) 1256 sys.exit(1)
1052else: 1257else:
1053 try: 1258 try:
1259 environment = os.environ.copy()
1260 environment["ROOT"] = "/"
1054 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE) 1261 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1055 if eselect_process.wait() != 0: 1262 if eselect_process.wait() != 0:
1056 raise ValueError 1263 raise ValueError
1057 except (OSError, ValueError): 1264 except (OSError, ValueError):
1058 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 1265 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1059 sys.exit(1) 1266 sys.exit(1)
1060 1267
1061 EPYTHON = eselect_process.stdout.read() 1268 EPYTHON = eselect_process.stdout.read()
1062 if not isinstance(EPYTHON, str): 1269 if not isinstance(EPYTHON, str):
1063 # Python 3 1270 # Python 3
1064 EPYTHON = EPYTHON.decode() 1271 EPYTHON = EPYTHON.decode()
1065 EPYTHON = EPYTHON.rstrip("\n") 1272 EPYTHON = EPYTHON.rstrip("\n")
1066 1273
1067 EPYTHON_matched = EPYTHON_re.match(EPYTHON) 1274 PYTHON_ABI = get_PYTHON_ABI(EPYTHON)
1068 if EPYTHON_matched: 1275 if PYTHON_ABI is None:
1069 PYTHON_ABI = EPYTHON_matched.group(1)
1070 else:
1071 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON) 1276 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], EPYTHON))
1072 sys.exit(1) 1277 sys.exit(1)
1278
1279wrapper_script_path = os.path.realpath(sys.argv[0])
1280target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1281if not os.path.exists(target_executable_path):
1282 sys.stderr.write("%s: '%s' does not exist\n" % (sys.argv[0], target_executable_path))
1283 sys.exit(1)
1073EOF 1284EOF
1074 if [[ "$?" != "0" ]]; then 1285 if [[ "$?" != "0" ]]; then
1075 die "${FUNCNAME}(): Generation of '$1' failed" 1286 die "${FUNCNAME}(): Generation of '$1' failed"
1076 fi 1287 fi
1077 else 1288 else
1078 cat << EOF >> "${file}" 1289 cat << EOF >> "${file}"
1079try: 1290try:
1291 environment = os.environ.copy()
1292 environment["ROOT"] = "/"
1080 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE) 1293 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1081 if eselect_process.wait() != 0: 1294 if eselect_process.wait() != 0:
1082 raise ValueError 1295 raise ValueError
1083except (OSError, ValueError): 1296except (OSError, ValueError):
1084 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 1297 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1085 sys.exit(1) 1298 sys.exit(1)
1086 1299
1087EPYTHON = eselect_process.stdout.read() 1300EPYTHON = eselect_process.stdout.read()
1088if not isinstance(EPYTHON, str): 1301if not isinstance(EPYTHON, str):
1089 # Python 3 1302 # Python 3
1090 EPYTHON = EPYTHON.decode() 1303 EPYTHON = EPYTHON.decode()
1091EPYTHON = EPYTHON.rstrip("\n") 1304EPYTHON = EPYTHON.rstrip("\n")
1092 1305
1093EPYTHON_matched = EPYTHON_re.match(EPYTHON) 1306PYTHON_ABI = get_PYTHON_ABI(EPYTHON)
1094if EPYTHON_matched: 1307if PYTHON_ABI is None:
1095 PYTHON_ABI = EPYTHON_matched.group(1) 1308 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], EPYTHON))
1309 sys.exit(1)
1310
1311wrapper_script_path = os.path.realpath(sys.argv[0])
1312for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]:
1313 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1314 if os.path.exists(target_executable_path):
1315 break
1096else: 1316else:
1097 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON) 1317 sys.stderr.write("%s: No target script exists for '%s'\n" % (sys.argv[0], wrapper_script_path))
1098 sys.exit(1) 1318 sys.exit(1)
1099EOF 1319EOF
1100 if [[ "$?" != "0" ]]; then 1320 if [[ "$?" != "0" ]]; then
1101 die "${FUNCNAME}(): Generation of '$1' failed" 1321 die "${FUNCNAME}(): Generation of '$1' failed"
1102 fi 1322 fi
1103 fi 1323 fi
1104 cat << EOF >> "${file}" 1324 cat << EOF >> "${file}"
1105
1106wrapper_script_path = os.path.realpath(sys.argv[0])
1107target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1108os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
1109os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
1110os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
1111if not os.path.exists(target_executable_path):
1112 sys.stderr.write("'%s' does not exist\n" % target_executable_path)
1113 sys.exit(1)
1114 1325
1115target_executable = open(target_executable_path, "rb") 1326target_executable = open(target_executable_path, "rb")
1116target_executable_first_line = target_executable.readline() 1327target_executable_first_line = target_executable.readline()
1117if not isinstance(target_executable_first_line, str): 1328if not isinstance(target_executable_first_line, str):
1118 # Python 3 1329 # Python 3
1119 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace") 1330 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace")
1120 1331
1121python_shebang_matched = python_shebang_re.match(target_executable_first_line) 1332python_shebang_matched = python_shebang_re.match(target_executable_first_line)
1122target_executable.close() 1333target_executable.close()
1123 1334
1124if python_shebang_matched: 1335if python_shebang_matched is not None:
1125 try: 1336 try:
1126 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % EPYTHON 1337 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % EPYTHON
1127 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1" 1338 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1"
1128 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE) 1339 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE)
1129 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] 1340 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
1136 python_verification_output = python_verification_output.decode() 1347 python_verification_output = python_verification_output.decode()
1137 1348
1138 if not python_verification_output_re.match(python_verification_output): 1349 if not python_verification_output_re.match(python_verification_output):
1139 raise ValueError 1350 raise ValueError
1140 1351
1352 if cpython_re.match(EPYTHON) is not None:
1353 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
1354 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
1355 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
1356
1357 if hasattr(os, "execv"):
1141 os.execv(python_interpreter_path, [python_interpreter_path] + sys.argv) 1358 os.execv(python_interpreter_path, [python_interpreter_path] + sys.argv)
1359 else:
1360 sys.exit(subprocess.Popen([python_interpreter_path] + sys.argv).wait())
1361 except (KeyboardInterrupt, SystemExit):
1362 raise
1142 except: 1363 except:
1143 pass 1364 pass
1144 if "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION" in os.environ: 1365 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"):
1145 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] 1366 if variable in os.environ:
1367 del os.environ[variable]
1146 1368
1369if hasattr(os, "execv"):
1147os.execv(target_executable_path, sys.argv) 1370 os.execv(target_executable_path, sys.argv)
1371else:
1372 sys.exit(subprocess.Popen([target_executable_path] + sys.argv[1:]).wait())
1148EOF 1373EOF
1149 if [[ "$?" != "0" ]]; then 1374 if [[ "$?" != "0" ]]; then
1150 die "${FUNCNAME}(): Generation of '$1' failed" 1375 die "${FUNCNAME}(): Generation of '$1' failed"
1151 fi 1376 fi
1152 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed" 1377 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed"
1153 done 1378 done
1154} 1379}
1155 1380
1381# @ECLASS-VARIABLE: PYTHON_VERSIONED_SCRIPTS
1382# @DESCRIPTION:
1383# Array of regular expressions of paths to versioned Python scripts.
1384# Python scripts in /usr/bin and /usr/sbin are versioned by default.
1385
1386# @ECLASS-VARIABLE: PYTHON_VERSIONED_EXECUTABLES
1387# @DESCRIPTION:
1388# Array of regular expressions of paths to versioned executables (including Python scripts).
1389
1390# @ECLASS-VARIABLE: PYTHON_NONVERSIONED_EXECUTABLES
1391# @DESCRIPTION:
1392# Array of regular expressions of paths to nonversioned executables (including Python scripts).
1393
1394# @FUNCTION: python_merge_intermediate_installation_images
1395# @USAGE: [-q|--quiet] [--] <intermediate_installation_images_directory>
1396# @DESCRIPTION:
1397# Merge intermediate installation images into installation image.
1398#
1399# This function can be used only in src_install() phase.
1400python_merge_intermediate_installation_images() {
1401 if [[ "${EBUILD_PHASE}" != "install" ]]; then
1402 die "${FUNCNAME}() can be used only in src_install() phase"
1403 fi
1404
1405 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1406 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1407 fi
1408
1409 _python_check_python_pkg_setup_execution
1410 _python_initialize_prefix_variables
1411
1412 local b file files=() intermediate_installation_images_directory PYTHON_ABI quiet="0" regex shebang version_executable wrapper_scripts=() wrapper_scripts_set=()
1413
1414 while (($#)); do
1415 case "$1" in
1416 -q|--quiet)
1417 quiet="1"
1418 ;;
1419 --)
1420 shift
1421 break
1422 ;;
1423 -*)
1424 die "${FUNCNAME}(): Unrecognized option '$1'"
1425 ;;
1426 *)
1427 break
1428 ;;
1429 esac
1430 shift
1431 done
1432
1433 if [[ "$#" -ne 1 ]]; then
1434 die "${FUNCNAME}() requires 1 argument"
1435 fi
1436
1437 intermediate_installation_images_directory="$1"
1438
1439 if [[ ! -d "${intermediate_installation_images_directory}" ]]; then
1440 die "${FUNCNAME}(): Intermediate installation images directory '${intermediate_installation_images_directory}' does not exist"
1441 fi
1442
1443 _python_calculate_PYTHON_ABIS
1444 if [[ "$(PYTHON -f --ABI)" == 3.* ]]; then
1445 b="b"
1446 fi
1447
1448 while read -d $'\0' -r file; do
1449 files+=("${file}")
1450 done < <("$(PYTHON -f)" -c \
1451"import os
1452import sys
1453
1454if hasattr(sys.stdout, 'buffer'):
1455 # Python 3
1456 stdout = sys.stdout.buffer
1457else:
1458 # Python 2
1459 stdout = sys.stdout
1460
1461files_set = set()
1462
1463os.chdir(${b}'${intermediate_installation_images_directory}')
1464
1465for PYTHON_ABI in ${b}'${PYTHON_ABIS}'.split():
1466 for root, dirs, files in os.walk(PYTHON_ABI + ${b}'${EPREFIX}'):
1467 root = root[len(PYTHON_ABI + ${b}'${EPREFIX}')+1:]
1468 files_set.update(root + ${b}'/' + file for file in files)
1469
1470for file in sorted(files_set):
1471 stdout.write(file)
1472 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of files in intermediate installation images")
1473
1474 for PYTHON_ABI in ${PYTHON_ABIS}; do
1475 if [[ ! -d "${intermediate_installation_images_directory}/${PYTHON_ABI}" ]]; then
1476 die "${FUNCNAME}(): Intermediate installation image for Python ABI '${PYTHON_ABI}' does not exist"
1477 fi
1478
1479 pushd "${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}" > /dev/null || die "pushd failed"
1480
1481 for file in "${files[@]}"; do
1482 version_executable="0"
1483 for regex in "/usr/bin/.*" "/usr/sbin/.*" "${PYTHON_VERSIONED_SCRIPTS[@]}"; do
1484 if [[ "/${file}" =~ ^${regex}$ ]]; then
1485 version_executable="1"
1486 break
1487 fi
1488 done
1489 for regex in "${PYTHON_VERSIONED_EXECUTABLES[@]}"; do
1490 if [[ "/${file}" =~ ^${regex}$ ]]; then
1491 version_executable="2"
1492 break
1493 fi
1494 done
1495 if [[ "${version_executable}" != "0" ]]; then
1496 for regex in "${PYTHON_NONVERSIONED_EXECUTABLES[@]}"; do
1497 if [[ "/${file}" =~ ^${regex}$ ]]; then
1498 version_executable="0"
1499 break
1500 fi
1501 done
1502 fi
1503
1504 [[ "${version_executable}" == "0" || ! -x "${file}" ]] && continue
1505
1506 shebang="$(head -n1 "${file}")" || die "Extraction of shebang from '${file}' failed"
1507
1508 if [[ "${version_executable}" == "2" ]]; then
1509 wrapper_scripts+=("${ED}${file}")
1510 elif [[ "${version_executable}" == "1" ]]; then
1511 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}([[:digit:]]+(\.[[:digit:]]+)?)?($|[[:space:]]+) ]]; then
1512 wrapper_scripts+=("${ED}${file}")
1513 else
1514 version_executable="0"
1515 fi
1516 fi
1517
1518 [[ "${version_executable}" == "0" ]] && continue
1519
1520 if [[ -e "${file}-${PYTHON_ABI}" ]]; then
1521 die "${FUNCNAME}(): '${EPREFIX}/${file}-${PYTHON_ABI}' already exists"
1522 fi
1523
1524 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed"
1525
1526 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}[[:digit:]]*($|[[:space:]]+) ]]; then
1527 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${file}-${PYTHON_ABI}"
1528 fi
1529 done
1530
1531 popd > /dev/null || die "popd failed"
1532
1533 if ROOT="/" has_version sys-apps/coreutils; then
1534 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1535 else
1536 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1537 fi
1538 done
1539
1540 rm -fr "${intermediate_installation_images_directory}"
1541
1542 if [[ "${#wrapper_scripts[@]}" -ge 1 ]]; then
1543 rm -f "${T}/python_wrapper_scripts"
1544
1545 for file in "${wrapper_scripts[@]}"; do
1546 echo -n "${file}" >> "${T}/python_wrapper_scripts"
1547 echo -en "\x00" >> "${T}/python_wrapper_scripts"
1548 done
1549
1550 while read -d $'\0' -r file; do
1551 wrapper_scripts_set+=("${file}")
1552 done < <("$(PYTHON -f)" -c \
1553"import sys
1554
1555if hasattr(sys.stdout, 'buffer'):
1556 # Python 3
1557 stdout = sys.stdout.buffer
1558else:
1559 # Python 2
1560 stdout = sys.stdout
1561
1562files = set(open('${T}/python_wrapper_scripts', 'rb').read().rstrip(${b}'\x00').split(${b}'\x00'))
1563
1564for file in sorted(files):
1565 stdout.write(file)
1566 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts")
1567
1568 python_generate_wrapper_scripts $([[ "${quiet}" == "1" ]] && echo --quiet) "${wrapper_scripts_set[@]}"
1569 fi
1570}
1571
1156# ================================================================================================ 1572# ================================================================================================
1157# ========= FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ========== 1573# ========= FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ==========
1158# ================================================================================================ 1574# ================================================================================================
1159 1575
1576unset EPYTHON PYTHON_ABI
1577
1160# @FUNCTION: python_set_active_version 1578# @FUNCTION: python_set_active_version
1161# @USAGE: <CPython_ABI|2|3> 1579# @USAGE: <Python_ABI|2|3>
1162# @DESCRIPTION: 1580# @DESCRIPTION:
1163# Set specified version of CPython as active version of Python. 1581# Set locally active version of Python.
1582# If Python_ABI argument is specified, then version of Python corresponding to Python_ABI is used.
1583# If 2 argument is specified, then active version of CPython 2 is used.
1584# If 3 argument is specified, then active version of CPython 3 is used.
1585#
1586# This function can be used only in pkg_setup() phase.
1164python_set_active_version() { 1587python_set_active_version() {
1588 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
1589 die "${FUNCNAME}() can be used only in pkg_setup() phase"
1590 fi
1591
1165 if _python_package_supporting_installation_for_multiple_python_abis; then 1592 if _python_package_supporting_installation_for_multiple_python_abis; then
1166 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs" 1593 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1167 fi 1594 fi
1168 1595
1169 if [[ "$#" -ne 1 ]]; then 1596 if [[ "$#" -ne 1 ]]; then
1170 die "${FUNCNAME}() requires 1 argument" 1597 die "${FUNCNAME}() requires 1 argument"
1171 fi 1598 fi
1172 1599
1173 _python_initial_sanity_checks 1600 _python_initial_sanity_checks
1174 1601
1175 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 1602 if [[ -z "${PYTHON_ABI}" ]]; then
1176 if ! _python_implementation && ! has_version "dev-lang/python:$1"; then 1603 if [[ -n "$(_python_get_implementation --ignore-invalid "$1")" ]]; then
1177 die "${FUNCNAME}(): 'dev-lang/python:$1' is not installed" 1604 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
1605 # so it does not need to be exported to subprocesses.
1606 PYTHON_ABI="$1"
1607 if ! _python_implementation && ! has_version "$(python_get_implementational_package)"; then
1608 die "${FUNCNAME}(): '$(python_get_implementational_package)' is not installed"
1178 fi 1609 fi
1179 export EPYTHON="$(PYTHON "$1")" 1610 export EPYTHON="$(PYTHON "$1")"
1180 elif [[ "$1" == "2" ]]; then 1611 elif [[ "$1" == "2" ]]; then
1181 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then 1612 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then
1182 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed" 1613 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed"
1183 fi 1614 fi
1184 export EPYTHON="$(PYTHON -2)" 1615 export EPYTHON="$(PYTHON -2)"
1616 PYTHON_ABI="${EPYTHON#python}"
1617 PYTHON_ABI="${PYTHON_ABI%%-*}"
1185 elif [[ "$1" == "3" ]]; then 1618 elif [[ "$1" == "3" ]]; then
1186 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then 1619 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then
1187 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed" 1620 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed"
1188 fi 1621 fi
1189 export EPYTHON="$(PYTHON -3)" 1622 export EPYTHON="$(PYTHON -3)"
1623 PYTHON_ABI="${EPYTHON#python}"
1624 PYTHON_ABI="${PYTHON_ABI%%-*}"
1190 else 1625 else
1191 die "${FUNCNAME}(): Unrecognized argument '$1'" 1626 die "${FUNCNAME}(): Unrecognized argument '$1'"
1192 fi 1627 fi
1193 1628 fi
1194 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
1195 # so it does not need to be exported to subprocesses.
1196 PYTHON_ABI="${EPYTHON#python}"
1197 PYTHON_ABI="${PYTHON_ABI%%-*}"
1198 1629
1199 _python_final_sanity_checks 1630 _python_final_sanity_checks
1200 1631
1201 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable. 1632 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
1202 PYTHON_REQUESTED_ACTIVE_VERSION="$1" 1633 PYTHON_REQUESTED_ACTIVE_VERSION="$1"
1208python_need_rebuild() { 1639python_need_rebuild() {
1209 if _python_package_supporting_installation_for_multiple_python_abis; then 1640 if _python_package_supporting_installation_for_multiple_python_abis; then
1210 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs" 1641 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1211 fi 1642 fi
1212 1643
1644 _python_check_python_pkg_setup_execution
1645
1646 if [[ "$#" -ne 0 ]]; then
1647 die "${FUNCNAME}() does not accept arguments"
1648 fi
1649
1213 export PYTHON_NEED_REBUILD="$(PYTHON --ABI)" 1650 export PYTHON_NEED_REBUILD="$(PYTHON --ABI)"
1214} 1651}
1215 1652
1216# ================================================================================================ 1653# ================================================================================================
1217# ======================================= GETTER FUNCTIONS ======================================= 1654# ======================================= GETTER FUNCTIONS =======================================
1222sys.stdout.write(".".join(str(x) for x in sys.version_info[:2])) 1659sys.stdout.write(".".join(str(x) for x in sys.version_info[:2]))
1223if platform.system()[:4] == "Java": 1660if platform.system()[:4] == "Java":
1224 sys.stdout.write("-jython")' 1661 sys.stdout.write("-jython")'
1225 1662
1226_python_get_implementation() { 1663_python_get_implementation() {
1664 local ignore_invalid="0"
1665
1666 while (($#)); do
1667 case "$1" in
1668 --ignore-invalid)
1669 ignore_invalid="1"
1670 ;;
1671 --)
1672 shift
1673 break
1674 ;;
1675 -*)
1676 die "${FUNCNAME}(): Unrecognized option '$1'"
1677 ;;
1678 *)
1679 break
1680 ;;
1681 esac
1682 shift
1683 done
1684
1227 if [[ "$#" -ne 1 ]]; then 1685 if [[ "$#" -ne 1 ]]; then
1228 die "${FUNCNAME}() requires 1 argument" 1686 die "${FUNCNAME}() requires 1 argument"
1229 fi 1687 fi
1230 1688
1231 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 1689 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
1232 echo "CPython" 1690 echo "CPython"
1233 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then 1691 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
1234 echo "Jython" 1692 echo "Jython"
1235 else 1693 else
1694 if [[ "${ignore_invalid}" == "0" ]]; then
1236 die "${FUNCNAME}(): Unrecognized Python ABI '$1'" 1695 die "${FUNCNAME}(): Unrecognized Python ABI '$1'"
1696 fi
1237 fi 1697 fi
1238} 1698}
1239 1699
1240# @FUNCTION: PYTHON 1700# @FUNCTION: PYTHON
1241# @USAGE: [-2] [-3] [--ABI] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}"> 1701# @USAGE: [-2] [-3] [--ABI] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}">
1242# @DESCRIPTION: 1702# @DESCRIPTION:
1243# Print filename of Python interpreter for specified Python ABI. If Python_ABI argument 1703# Print filename of Python interpreter for specified Python ABI. If Python_ABI argument
1244# is ommitted, then PYTHON_ABI environment variable must be set and is used. 1704# is ommitted, then PYTHON_ABI environment variable must be set and is used.
1245# If -2 option is specified, then active version of Python 2 is used. 1705# If -2 option is specified, then active version of CPython 2 is used.
1246# If -3 option is specified, then active version of Python 3 is used. 1706# If -3 option is specified, then active version of CPython 3 is used.
1247# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1707# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1248# -2, -3 and --final-ABI options and Python_ABI argument cannot be specified simultaneously. 1708# -2, -3 and --final-ABI options and Python_ABI argument cannot be specified simultaneously.
1249# If --ABI option is specified, then only specified Python ABI is printed instead of 1709# If --ABI option is specified, then only specified Python ABI is printed instead of
1250# filename of Python interpreter. 1710# filename of Python interpreter.
1251# If --absolute-path option is specified, then absolute path to Python interpreter is printed. 1711# If --absolute-path option is specified, then absolute path to Python interpreter is printed.
1252# --ABI and --absolute-path options cannot be specified simultaneously. 1712# --ABI and --absolute-path options cannot be specified simultaneously.
1253PYTHON() { 1713PYTHON() {
1714 _python_check_python_pkg_setup_execution
1715
1254 local ABI_output="0" absolute_path_output="0" final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" python_interpreter python2="0" python3="0" 1716 local ABI_output="0" absolute_path_output="0" final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" python_interpreter python2="0" python3="0"
1255 1717
1256 while (($#)); do 1718 while (($#)); do
1257 case "$1" in 1719 case "$1" in
1258 -2) 1720 -2)
1283 esac 1745 esac
1284 shift 1746 shift
1285 done 1747 done
1286 1748
1287 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then 1749 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then
1288 die "${FUNCNAME}(): '--ABI and '--absolute-path' options cannot be specified simultaneously" 1750 die "${FUNCNAME}(): '--ABI' and '--absolute-path' options cannot be specified simultaneously"
1289 fi 1751 fi
1290 1752
1291 if [[ "$((${python2} + ${python3} + ${final_ABI}))" -gt 1 ]]; then 1753 if [[ "$((${python2} + ${python3} + ${final_ABI}))" -gt 1 ]]; then
1292 die "${FUNCNAME}(): '-2', '-3' or '--final-ABI' options cannot be specified simultaneously" 1754 die "${FUNCNAME}(): '-2', '-3' or '--final-ABI' options cannot be specified simultaneously"
1293 fi 1755 fi
1298 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1760 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1299 fi 1761 fi
1300 _python_calculate_PYTHON_ABIS 1762 _python_calculate_PYTHON_ABIS
1301 PYTHON_ABI="${PYTHON_ABIS##* }" 1763 PYTHON_ABI="${PYTHON_ABIS##* }"
1302 elif [[ "${python2}" == "1" ]]; then 1764 elif [[ "${python2}" == "1" ]]; then
1303 PYTHON_ABI="$(eselect python show --python2 --ABI)" 1765 PYTHON_ABI="$(ROOT="/" eselect python show --python2 --ABI)"
1304 if [[ -z "${PYTHON_ABI}" ]]; then 1766 if [[ -z "${PYTHON_ABI}" ]]; then
1305 die "${FUNCNAME}(): Active version of Python 2 not set" 1767 die "${FUNCNAME}(): Active version of CPython 2 not set"
1306 elif [[ "${PYTHON_ABI}" != "2."* ]]; then 1768 elif [[ "${PYTHON_ABI}" != "2."* ]]; then
1307 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`" 1769 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
1308 fi 1770 fi
1309 elif [[ "${python3}" == "1" ]]; then 1771 elif [[ "${python3}" == "1" ]]; then
1310 PYTHON_ABI="$(eselect python show --python3 --ABI)" 1772 PYTHON_ABI="$(ROOT="/" eselect python show --python3 --ABI)"
1311 if [[ -z "${PYTHON_ABI}" ]]; then 1773 if [[ -z "${PYTHON_ABI}" ]]; then
1312 die "${FUNCNAME}(): Active version of Python 3 not set" 1774 die "${FUNCNAME}(): Active version of CPython 3 not set"
1313 elif [[ "${PYTHON_ABI}" != "3."* ]]; then 1775 elif [[ "${PYTHON_ABI}" != "3."* ]]; then
1314 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`" 1776 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
1315 fi 1777 fi
1316 elif ! _python_package_supporting_installation_for_multiple_python_abis; then 1778 elif _python_package_supporting_installation_for_multiple_python_abis; then
1779 if ! _python_abi-specific_local_scope; then
1780 die "${FUNCNAME}() should be used in ABI-specific local scope"
1781 fi
1782 else
1317 PYTHON_ABI="$("${EPREFIX}/usr/bin/python" -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")" 1783 PYTHON_ABI="$("${EPREFIX}/usr/bin/python" -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")"
1318 if [[ -z "${PYTHON_ABI}" ]]; then 1784 if [[ -z "${PYTHON_ABI}" ]]; then
1319 die "${FUNCNAME}(): Failure of extraction of locally active version of Python" 1785 die "${FUNCNAME}(): Failure of extraction of locally active version of Python"
1320 fi 1786 fi
1321 elif [[ -z "${PYTHON_ABI}" ]]; then
1322 die "${FUNCNAME}(): Invalid usage: ${FUNCNAME}() should be used in ABI-specific local scope"
1323 fi 1787 fi
1324 elif [[ "$#" -eq 1 ]]; then 1788 elif [[ "$#" -eq 1 ]]; then
1325 if [[ "${final_ABI}" == "1" ]]; then 1789 if [[ "${final_ABI}" == "1" ]]; then
1326 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously" 1790 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously"
1327 fi 1791 fi
1341 return 1805 return
1342 else 1806 else
1343 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1807 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1344 python_interpreter="python${PYTHON_ABI}" 1808 python_interpreter="python${PYTHON_ABI}"
1345 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1809 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1346 python_interpreter="jython-${PYTHON_ABI%-jython}" 1810 python_interpreter="jython${PYTHON_ABI%-jython}"
1347 fi 1811 fi
1348 1812
1349 if [[ "${absolute_path_output}" == "1" ]]; then 1813 if [[ "${absolute_path_output}" == "1" ]]; then
1350 echo -n "${EPREFIX}/usr/bin/${python_interpreter}" 1814 echo -n "${EPREFIX}/usr/bin/${python_interpreter}"
1351 else 1815 else
1362# @USAGE: [-f|--final-ABI] 1826# @USAGE: [-f|--final-ABI]
1363# @DESCRIPTION: 1827# @DESCRIPTION:
1364# Print name of Python implementation. 1828# Print name of Python implementation.
1365# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1829# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1366python_get_implementation() { 1830python_get_implementation() {
1831 _python_check_python_pkg_setup_execution
1832
1367 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" 1833 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1368 1834
1369 while (($#)); do 1835 while (($#)); do
1370 case "$1" in 1836 case "$1" in
1371 -f|--final-ABI) 1837 -f|--final-ABI)
1384 if [[ "${final_ABI}" == "1" ]]; then 1850 if [[ "${final_ABI}" == "1" ]]; then
1385 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1851 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1386 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1852 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1387 fi 1853 fi
1388 PYTHON_ABI="$(PYTHON -f --ABI)" 1854 PYTHON_ABI="$(PYTHON -f --ABI)"
1389 elif [[ -z "${PYTHON_ABI}" ]]; then 1855 else
1856 if _python_package_supporting_installation_for_multiple_python_abis; then
1857 if ! _python_abi-specific_local_scope; then
1858 die "${FUNCNAME}() should be used in ABI-specific local scope"
1859 fi
1860 else
1390 PYTHON_ABI="$(PYTHON --ABI)" 1861 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1862 fi
1391 fi 1863 fi
1392 1864
1393 echo "$(_python_get_implementation "${PYTHON_ABI}")" 1865 echo "$(_python_get_implementation "${PYTHON_ABI}")"
1394} 1866}
1395 1867
1397# @USAGE: [-f|--final-ABI] 1869# @USAGE: [-f|--final-ABI]
1398# @DESCRIPTION: 1870# @DESCRIPTION:
1399# Print category, name and slot of package providing Python implementation. 1871# Print category, name and slot of package providing Python implementation.
1400# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1872# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1401python_get_implementational_package() { 1873python_get_implementational_package() {
1874 _python_check_python_pkg_setup_execution
1875
1402 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" 1876 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1403 1877
1404 while (($#)); do 1878 while (($#)); do
1405 case "$1" in 1879 case "$1" in
1406 -f|--final-ABI) 1880 -f|--final-ABI)
1419 if [[ "${final_ABI}" == "1" ]]; then 1893 if [[ "${final_ABI}" == "1" ]]; then
1420 if ! _python_package_supporting_installation_for_multiple_python_abis; then 1894 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1421 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1895 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1422 fi 1896 fi
1423 PYTHON_ABI="$(PYTHON -f --ABI)" 1897 PYTHON_ABI="$(PYTHON -f --ABI)"
1424 elif [[ -z "${PYTHON_ABI}" ]]; then 1898 else
1899 if _python_package_supporting_installation_for_multiple_python_abis; then
1900 if ! _python_abi-specific_local_scope; then
1901 die "${FUNCNAME}() should be used in ABI-specific local scope"
1902 fi
1903 else
1425 PYTHON_ABI="$(PYTHON --ABI)" 1904 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1426 fi 1905 fi
1906 fi
1427 1907
1908 if [[ "${EAPI:-0}" == "0" ]]; then
1428 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1909 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1429 echo "dev-lang/python:${PYTHON_ABI}" 1910 echo "=dev-lang/python-${PYTHON_ABI}*"
1430 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1911 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1912 echo "=dev-java/jython-${PYTHON_ABI%-jython}*"
1913 fi
1914 else
1915 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1916 echo "dev-lang/python:${PYTHON_ABI}"
1917 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1431 echo "dev-java/jython:${PYTHON_ABI%-jython}" 1918 echo "dev-java/jython:${PYTHON_ABI%-jython}"
1919 fi
1432 fi 1920 fi
1433} 1921}
1434 1922
1435# @FUNCTION: python_get_includedir 1923# @FUNCTION: python_get_includedir
1436# @USAGE: [-f|--final-ABI] 1924# @USAGE: [-b|--base-path] [-f|--final-ABI]
1437# @DESCRIPTION: 1925# @DESCRIPTION:
1438# Print path to Python include directory. 1926# Print path to Python include directory.
1927# If --base-path option is specified, then path not prefixed with "/" is printed.
1439# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 1928# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1440python_get_includedir() { 1929python_get_includedir() {
1930 _python_check_python_pkg_setup_execution
1931
1441 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" 1932 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
1933
1934 while (($#)); do
1935 case "$1" in
1936 -b|--base-path)
1937 base_path="1"
1938 ;;
1939 -f|--final-ABI)
1940 final_ABI="1"
1941 ;;
1942 -*)
1943 die "${FUNCNAME}(): Unrecognized option '$1'"
1944 ;;
1945 *)
1946 die "${FUNCNAME}(): Invalid usage"
1947 ;;
1948 esac
1949 shift
1950 done
1951
1952 if [[ "${base_path}" == "0" ]]; then
1953 prefix="/"
1954 fi
1955
1956 if [[ "${final_ABI}" == "1" ]]; then
1957 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1958 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1959 fi
1960 PYTHON_ABI="$(PYTHON -f --ABI)"
1961 else
1962 if _python_package_supporting_installation_for_multiple_python_abis; then
1963 if ! _python_abi-specific_local_scope; then
1964 die "${FUNCNAME}() should be used in ABI-specific local scope"
1965 fi
1966 else
1967 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1968 fi
1969 fi
1970
1971 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1972 echo "${prefix}usr/include/python${PYTHON_ABI}"
1973 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1974 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include"
1975 fi
1976}
1977
1978# @FUNCTION: python_get_libdir
1979# @USAGE: [-b|--base-path] [-f|--final-ABI]
1980# @DESCRIPTION:
1981# Print path to Python library directory.
1982# If --base-path option is specified, then path not prefixed with "/" is printed.
1983# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1984python_get_libdir() {
1985 _python_check_python_pkg_setup_execution
1986
1987 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
1988
1989 while (($#)); do
1990 case "$1" in
1991 -b|--base-path)
1992 base_path="1"
1993 ;;
1994 -f|--final-ABI)
1995 final_ABI="1"
1996 ;;
1997 -*)
1998 die "${FUNCNAME}(): Unrecognized option '$1'"
1999 ;;
2000 *)
2001 die "${FUNCNAME}(): Invalid usage"
2002 ;;
2003 esac
2004 shift
2005 done
2006
2007 if [[ "${base_path}" == "0" ]]; then
2008 prefix="/"
2009 fi
2010
2011 if [[ "${final_ABI}" == "1" ]]; then
2012 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2013 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2014 fi
2015 PYTHON_ABI="$(PYTHON -f --ABI)"
2016 else
2017 if _python_package_supporting_installation_for_multiple_python_abis; then
2018 if ! _python_abi-specific_local_scope; then
2019 die "${FUNCNAME}() should be used in ABI-specific local scope"
2020 fi
2021 else
2022 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2023 fi
2024 fi
2025
2026 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2027 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}"
2028 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2029 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib"
2030 fi
2031}
2032
2033# @FUNCTION: python_get_sitedir
2034# @USAGE: [-b|--base-path] [-f|--final-ABI]
2035# @DESCRIPTION:
2036# Print path to Python site-packages directory.
2037# If --base-path option is specified, then path not prefixed with "/" is printed.
2038# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2039python_get_sitedir() {
2040 _python_check_python_pkg_setup_execution
2041
2042 local final_ABI="0" options=()
2043
2044 while (($#)); do
2045 case "$1" in
2046 -b|--base-path)
2047 options+=("$1")
2048 ;;
2049 -f|--final-ABI)
2050 final_ABI="1"
2051 options+=("$1")
2052 ;;
2053 -*)
2054 die "${FUNCNAME}(): Unrecognized option '$1'"
2055 ;;
2056 *)
2057 die "${FUNCNAME}(): Invalid usage"
2058 ;;
2059 esac
2060 shift
2061 done
2062
2063 if [[ "${final_ABI}" == "1" ]]; then
2064 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2065 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2066 fi
2067 else
2068 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
2069 die "${FUNCNAME}() should be used in ABI-specific local scope"
2070 fi
2071 fi
2072
2073 echo "$(python_get_libdir "${options[@]}")/site-packages"
2074}
2075
2076# @FUNCTION: python_get_library
2077# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option]
2078# @DESCRIPTION:
2079# Print path to Python library.
2080# If --base-path option is specified, then path not prefixed with "/" is printed.
2081# If --linker-option is specified, then "-l${library}" linker option is printed.
2082# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2083python_get_library() {
2084 _python_check_python_pkg_setup_execution
2085
2086 local base_path="0" final_ABI="0" linker_option="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2087
2088 while (($#)); do
2089 case "$1" in
2090 -b|--base-path)
2091 base_path="1"
2092 ;;
2093 -f|--final-ABI)
2094 final_ABI="1"
2095 ;;
2096 -l|--linker-option)
2097 linker_option="1"
2098 ;;
2099 -*)
2100 die "${FUNCNAME}(): Unrecognized option '$1'"
2101 ;;
2102 *)
2103 die "${FUNCNAME}(): Invalid usage"
2104 ;;
2105 esac
2106 shift
2107 done
2108
2109 if [[ "${base_path}" == "0" ]]; then
2110 prefix="/"
2111 fi
2112
2113 if [[ "${base_path}" == "1" && "${linker_option}" == "1" ]]; then
2114 die "${FUNCNAME}(): '--base-path' and '--linker-option' options cannot be specified simultaneously"
2115 fi
2116
2117 if [[ "${final_ABI}" == "1" ]]; then
2118 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2119 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2120 fi
2121 PYTHON_ABI="$(PYTHON -f --ABI)"
2122 else
2123 if _python_package_supporting_installation_for_multiple_python_abis; then
2124 if ! _python_abi-specific_local_scope; then
2125 die "${FUNCNAME}() should be used in ABI-specific local scope"
2126 fi
2127 else
2128 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2129 fi
2130 fi
2131
2132 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2133 if [[ "${linker_option}" == "1" ]]; then
2134 echo "-lpython${PYTHON_ABI}"
2135 else
2136 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)"
2137 fi
2138 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2139 die "${FUNCNAME}(): Jython does not have shared library"
2140 fi
2141}
2142
2143# @FUNCTION: python_get_version
2144# @USAGE: [-f|--final-ABI] [-l|--language] [--full] [--major] [--minor] [--micro]
2145# @DESCRIPTION:
2146# Print version of Python implementation.
2147# --full, --major, --minor and --micro options cannot be specified simultaneously.
2148# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
2149# If --language option is specified, then version of Python language is printed.
2150# --language and --full options cannot be specified simultaneously.
2151# --language and --micro options cannot be specified simultaneously.
2152# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2153python_get_version() {
2154 _python_check_python_pkg_setup_execution
2155
2156 local final_ABI="0" language="0" language_version full="0" major="0" minor="0" micro="0" PYTHON_ABI="${PYTHON_ABI}" python_command
1442 2157
1443 while (($#)); do 2158 while (($#)); do
1444 case "$1" in 2159 case "$1" in
1445 -f|--final-ABI) 2160 -f|--final-ABI)
1446 final_ABI="1" 2161 final_ABI="1"
1447 ;; 2162 ;;
2163 -l|--language)
2164 language="1"
2165 ;;
2166 --full)
2167 full="1"
2168 ;;
2169 --major)
2170 major="1"
2171 ;;
2172 --minor)
2173 minor="1"
2174 ;;
2175 --micro)
2176 micro="1"
2177 ;;
1448 -*) 2178 -*)
1449 die "${FUNCNAME}(): Unrecognized option '$1'" 2179 die "${FUNCNAME}(): Unrecognized option '$1'"
1450 ;; 2180 ;;
1451 *) 2181 *)
1452 die "${FUNCNAME}(): Invalid usage" 2182 die "${FUNCNAME}(): Invalid usage"
1457 2187
1458 if [[ "${final_ABI}" == "1" ]]; then 2188 if [[ "${final_ABI}" == "1" ]]; then
1459 if ! _python_package_supporting_installation_for_multiple_python_abis; then 2189 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1460 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 2190 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1461 fi 2191 fi
2192 else
2193 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
2194 die "${FUNCNAME}() should be used in ABI-specific local scope"
2195 fi
2196 fi
2197
2198 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
2199 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
2200 fi
2201
2202 if [[ "${language}" == "1" ]]; then
2203 if [[ "${final_ABI}" == "1" ]]; then
1462 PYTHON_ABI="$(PYTHON -f --ABI)" 2204 PYTHON_ABI="$(PYTHON -f --ABI)"
1463 elif [[ -z "${PYTHON_ABI}" ]]; then 2205 elif [[ -z "${PYTHON_ABI}" ]]; then
1464 PYTHON_ABI="$(PYTHON --ABI)" 2206 PYTHON_ABI="$(PYTHON --ABI)"
1465 fi 2207 fi
1466 2208 language_version="${PYTHON_ABI%%-*}"
2209 if [[ "${full}" == "1" ]]; then
2210 die "${FUNCNAME}(): '--language' and '--full' options cannot be specified simultaneously"
2211 elif [[ "${major}" == "1" ]]; then
2212 echo "${language_version%.*}"
2213 elif [[ "${minor}" == "1" ]]; then
2214 echo "${language_version#*.}"
2215 elif [[ "${micro}" == "1" ]]; then
2216 die "${FUNCNAME}(): '--language' and '--micro' options cannot be specified simultaneously"
2217 else
2218 echo "${language_version}"
2219 fi
2220 else
2221 if [[ "${full}" == "1" ]]; then
2222 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:3]))"
2223 elif [[ "${major}" == "1" ]]; then
2224 python_command="from sys import version_info; print(version_info[0])"
2225 elif [[ "${minor}" == "1" ]]; then
2226 python_command="from sys import version_info; print(version_info[1])"
2227 elif [[ "${micro}" == "1" ]]; then
2228 python_command="from sys import version_info; print(version_info[2])"
2229 else
2230 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
1467 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2231 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1468 echo "/usr/include/python${PYTHON_ABI}" 2232 echo "${PYTHON_ABI}"
1469 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2233 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1470 echo "/usr/share/jython-${PYTHON_ABI%-jython}/Include" 2234 echo "${PYTHON_ABI%-jython}"
2235 fi
2236 return
2237 fi
2238 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
1471 fi 2239 fi
1472}
1473 2240
1474# @FUNCTION: python_get_libdir 2241 if [[ "${final_ABI}" == "1" ]]; then
2242 "$(PYTHON -f)" -c "${python_command}"
2243 else
2244 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
2245 fi
2246 fi
2247}
2248
2249# @FUNCTION: python_get_implementation_and_version
1475# @USAGE: [-f|--final-ABI] 2250# @USAGE: [-f|--final-ABI]
1476# @DESCRIPTION: 2251# @DESCRIPTION:
1477# Print path to Python library directory. 2252# Print name and version of Python implementation.
2253# If version of Python implementation is not bound to version of Python language, then
2254# version of Python language is additionally printed.
1478# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2255# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1479python_get_libdir() { 2256python_get_implementation_and_version() {
2257 _python_check_python_pkg_setup_execution
2258
1480 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" 2259 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1481 2260
1482 while (($#)); do 2261 while (($#)); do
1483 case "$1" in 2262 case "$1" in
1484 -f|--final-ABI) 2263 -f|--final-ABI)
1497 if [[ "${final_ABI}" == "1" ]]; then 2276 if [[ "${final_ABI}" == "1" ]]; then
1498 if ! _python_package_supporting_installation_for_multiple_python_abis; then 2277 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1499 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 2278 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1500 fi 2279 fi
1501 PYTHON_ABI="$(PYTHON -f --ABI)" 2280 PYTHON_ABI="$(PYTHON -f --ABI)"
1502 elif [[ -z "${PYTHON_ABI}" ]]; then 2281 else
1503 PYTHON_ABI="$(PYTHON --ABI)"
1504 fi
1505
1506 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1507 echo "/usr/$(get_libdir)/python${PYTHON_ABI}"
1508 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1509 echo "/usr/share/jython-${PYTHON_ABI%-jython}/Lib"
1510 fi
1511}
1512
1513# @FUNCTION: python_get_sitedir
1514# @USAGE: [-f|--final-ABI]
1515# @DESCRIPTION:
1516# Print path to Python site-packages directory.
1517# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1518python_get_sitedir() {
1519 local options=()
1520
1521 while (($#)); do
1522 case "$1" in
1523 -f|--final-ABI)
1524 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1525 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1526 fi
1527 options+=("$1")
1528 ;;
1529 -*)
1530 die "${FUNCNAME}(): Unrecognized option '$1'"
1531 ;;
1532 *)
1533 die "${FUNCNAME}(): Invalid usage"
1534 ;;
1535 esac
1536 shift
1537 done
1538
1539 echo "$(python_get_libdir "${options[@]}")/site-packages"
1540}
1541
1542# @FUNCTION: python_get_library
1543# @USAGE: [-f|--final-ABI] [-l|--linker-option]
1544# @DESCRIPTION:
1545# Print path to Python library.
1546# If --linker-option is specified, then "-l${library}" linker option is printed.
1547# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1548python_get_library() {
1549 local final_ABI="0" linker_option="0" PYTHON_ABI="${PYTHON_ABI}"
1550
1551 while (($#)); do
1552 case "$1" in
1553 -f|--final-ABI)
1554 final_ABI="1"
1555 ;;
1556 -l|--linker-option)
1557 linker_option="1"
1558 ;;
1559 -*)
1560 die "${FUNCNAME}(): Unrecognized option '$1'"
1561 ;;
1562 *)
1563 die "${FUNCNAME}(): Invalid usage"
1564 ;;
1565 esac
1566 shift
1567 done
1568
1569 if [[ "${final_ABI}" == "1" ]]; then
1570 if ! _python_package_supporting_installation_for_multiple_python_abis; then 2282 if _python_package_supporting_installation_for_multiple_python_abis; then
1571 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 2283 if ! _python_abi-specific_local_scope; then
2284 die "${FUNCNAME}() should be used in ABI-specific local scope"
1572 fi 2285 fi
1573 PYTHON_ABI="$(PYTHON -f --ABI)"
1574 elif [[ -z "${PYTHON_ABI}" ]]; then
1575 PYTHON_ABI="$(PYTHON --ABI)"
1576 fi
1577
1578 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1579 if [[ "${linker_option}" == "1" ]]; then
1580 echo "-lpython${PYTHON_ABI}"
1581 else 2286 else
1582 echo "/usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)" 2287 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
1583 fi
1584 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1585 die "${FUNCNAME}(): Jython does not have shared library"
1586 fi
1587}
1588
1589# @FUNCTION: python_get_version
1590# @USAGE: [-f|--final-ABI] [--full] [--major] [--minor] [--micro]
1591# @DESCRIPTION:
1592# Print Python version.
1593# --full, --major, --minor and --micro options cannot be specified simultaneously.
1594# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
1595# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1596python_get_version() {
1597 local final_ABI="0" full="0" major="0" minor="0" micro="0" python_command
1598
1599 while (($#)); do
1600 case "$1" in
1601 -f|--final-ABI)
1602 final_ABI="1"
1603 ;;
1604 --full)
1605 full="1"
1606 ;;
1607 --major)
1608 major="1"
1609 ;;
1610 --minor)
1611 minor="1"
1612 ;;
1613 --micro)
1614 micro="1"
1615 ;;
1616 -*)
1617 die "${FUNCNAME}(): Unrecognized option '$1'"
1618 ;;
1619 *)
1620 die "${FUNCNAME}(): Invalid usage"
1621 ;;
1622 esac
1623 shift
1624 done
1625
1626 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
1627 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
1628 fi
1629
1630 if [[ "${full}" == "1" ]]; then
1631 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:3]))"
1632 elif [[ "${major}" == "1" ]]; then
1633 python_command="from sys import version_info; print(version_info[0])"
1634 elif [[ "${minor}" == "1" ]]; then
1635 python_command="from sys import version_info; print(version_info[1])"
1636 elif [[ "${micro}" == "1" ]]; then
1637 python_command="from sys import version_info; print(version_info[2])"
1638 else
1639 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
1640 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1641 echo "${PYTHON_ABI}"
1642 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1643 echo "${PYTHON_ABI%-jython}"
1644 fi 2288 fi
1645 return
1646 fi 2289 fi
1647 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
1648 fi
1649 2290
1650 if [[ "${final_ABI}" == "1" ]]; then 2291 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-[[:alnum:]]+-[[:digit:]]+\.[[:digit:]]+$ ]]; then
1651 if ! _python_package_supporting_installation_for_multiple_python_abis; then 2292 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI##*-} (Python ${PYTHON_ABI%%-*})"
1652 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1653 fi
1654 "$(PYTHON -f)" -c "${python_command}"
1655 else 2293 else
1656 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}" 2294 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI%%-*}"
1657 fi 2295 fi
1658} 2296}
1659 2297
1660# ================================================================================================ 2298# ================================================================================================
1661# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================ 2299# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================
1682# @DESCRIPTION: 2320# @DESCRIPTION:
1683# Execute nosetests for all enabled Python ABIs. 2321# Execute nosetests for all enabled Python ABIs.
1684# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls 2322# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
1685# python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined. 2323# python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined.
1686python_execute_nosetests() { 2324python_execute_nosetests() {
2325 _python_check_python_pkg_setup_execution
1687 _python_set_color_variables 2326 _python_set_color_variables
1688 2327
1689 local PYTHONPATH_template= separate_build_dirs= 2328 local PYTHONPATH_template separate_build_dirs
1690 2329
1691 while (($#)); do 2330 while (($#)); do
1692 case "$1" in 2331 case "$1" in
1693 -P|--PYTHONPATH) 2332 -P|--PYTHONPATH)
1694 PYTHONPATH_template="$2" 2333 PYTHONPATH_template="$2"
1710 esac 2349 esac
1711 shift 2350 shift
1712 done 2351 done
1713 2352
1714 python_test_function() { 2353 python_test_function() {
1715 local evaluated_PYTHONPATH= 2354 local evaluated_PYTHONPATH
1716 2355
1717 if [[ -n "${PYTHONPATH_template}" ]]; then
1718 evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")" 2356 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
1719 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1720 unset evaluated_PYTHONPATH
1721 fi
1722 fi
1723 2357
1724 _python_test_hook pre 2358 _python_test_hook pre
1725 2359
1726 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2360 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1727 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 2361 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
1750# @DESCRIPTION: 2384# @DESCRIPTION:
1751# Execute py.test for all enabled Python ABIs. 2385# Execute py.test for all enabled Python ABIs.
1752# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls 2386# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
1753# python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined. 2387# python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined.
1754python_execute_py.test() { 2388python_execute_py.test() {
2389 _python_check_python_pkg_setup_execution
1755 _python_set_color_variables 2390 _python_set_color_variables
1756 2391
1757 local PYTHONPATH_template= separate_build_dirs= 2392 local PYTHONPATH_template separate_build_dirs
1758 2393
1759 while (($#)); do 2394 while (($#)); do
1760 case "$1" in 2395 case "$1" in
1761 -P|--PYTHONPATH) 2396 -P|--PYTHONPATH)
1762 PYTHONPATH_template="$2" 2397 PYTHONPATH_template="$2"
1778 esac 2413 esac
1779 shift 2414 shift
1780 done 2415 done
1781 2416
1782 python_test_function() { 2417 python_test_function() {
1783 local evaluated_PYTHONPATH= 2418 local evaluated_PYTHONPATH
1784 2419
1785 if [[ -n "${PYTHONPATH_template}" ]]; then
1786 evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")" 2420 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
1787 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1788 unset evaluated_PYTHONPATH
1789 fi
1790 fi
1791 2421
1792 _python_test_hook pre 2422 _python_test_hook pre
1793 2423
1794 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2424 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1795 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL} 2425 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
1818# @DESCRIPTION: 2448# @DESCRIPTION:
1819# Execute trial for all enabled Python ABIs. 2449# Execute trial for all enabled Python ABIs.
1820# In ebuilds of packages supporting installation for multiple Python ABIs, this function 2450# In ebuilds of packages supporting installation for multiple Python ABIs, this function
1821# calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined. 2451# calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined.
1822python_execute_trial() { 2452python_execute_trial() {
2453 _python_check_python_pkg_setup_execution
1823 _python_set_color_variables 2454 _python_set_color_variables
1824 2455
1825 local PYTHONPATH_template= separate_build_dirs= 2456 local PYTHONPATH_template separate_build_dirs
1826 2457
1827 while (($#)); do 2458 while (($#)); do
1828 case "$1" in 2459 case "$1" in
1829 -P|--PYTHONPATH) 2460 -P|--PYTHONPATH)
1830 PYTHONPATH_template="$2" 2461 PYTHONPATH_template="$2"
1846 esac 2477 esac
1847 shift 2478 shift
1848 done 2479 done
1849 2480
1850 python_test_function() { 2481 python_test_function() {
1851 local evaluated_PYTHONPATH= 2482 local evaluated_PYTHONPATH
1852 2483
1853 if [[ -n "${PYTHONPATH_template}" ]]; then
1854 evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")" 2484 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
1855 if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1856 unset evaluated_PYTHONPATH
1857 fi
1858 fi
1859 2485
1860 _python_test_hook pre 2486 _python_test_hook pre
1861 2487
1862 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2488 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1863 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2489 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
1888# @FUNCTION: python_enable_pyc 2514# @FUNCTION: python_enable_pyc
1889# @DESCRIPTION: 2515# @DESCRIPTION:
1890# Tell Python to automatically recompile modules to .pyc/.pyo if the 2516# Tell Python to automatically recompile modules to .pyc/.pyo if the
1891# timestamps/version stamps have changed. 2517# timestamps/version stamps have changed.
1892python_enable_pyc() { 2518python_enable_pyc() {
2519 _python_check_python_pkg_setup_execution
2520
2521 if [[ "$#" -ne 0 ]]; then
2522 die "${FUNCNAME}() does not accept arguments"
2523 fi
2524
1893 unset PYTHONDONTWRITEBYTECODE 2525 unset PYTHONDONTWRITEBYTECODE
1894} 2526}
1895 2527
1896# @FUNCTION: python_disable_pyc 2528# @FUNCTION: python_disable_pyc
1897# @DESCRIPTION: 2529# @DESCRIPTION:
1898# Tell Python not to automatically recompile modules to .pyc/.pyo 2530# Tell Python not to automatically recompile modules to .pyc/.pyo
1899# even if the timestamps/version stamps do not match. This is done 2531# even if the timestamps/version stamps do not match. This is done
1900# to protect sandbox. 2532# to protect sandbox.
1901python_disable_pyc() { 2533python_disable_pyc() {
2534 _python_check_python_pkg_setup_execution
2535
2536 if [[ "$#" -ne 0 ]]; then
2537 die "${FUNCNAME}() does not accept arguments"
2538 fi
2539
1902 export PYTHONDONTWRITEBYTECODE="1" 2540 export PYTHONDONTWRITEBYTECODE="1"
1903} 2541}
1904 2542
1905_python_clean_compiled_modules() { 2543_python_clean_compiled_modules() {
1906 _python_initialize_prefix_variables 2544 _python_initialize_prefix_variables
1907 _python_set_color_variables 2545 _python_set_color_variables
1908 2546
1909 [[ "${FUNCNAME[1]}" =~ ^(python_mod_optimize|python_mod_compile|python_mod_cleanup)$ ]] || die "${FUNCNAME}(): Invalid usage" 2547 [[ "${FUNCNAME[1]}" =~ ^(python_mod_optimize|python_mod_cleanup)$ ]] || die "${FUNCNAME}(): Invalid usage"
1910 2548
1911 local base_module_name compiled_file compiled_files=() dir path py_file root 2549 local base_module_name compiled_file compiled_files=() dir path py_file root
1912 2550
1913 # Strip trailing slash from EROOT. 2551 # Strip trailing slash from EROOT.
1914 root="${EROOT%/}" 2552 root="${EROOT%/}"
1921 done < <(find "${path}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -print0) 2559 done < <(find "${path}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -print0)
1922 2560
1923 if [[ "${EBUILD_PHASE}" == "postrm" ]]; then 2561 if [[ "${EBUILD_PHASE}" == "postrm" ]]; then
1924 # Delete empty child directories. 2562 # Delete empty child directories.
1925 find "${path}" -type d | sort -r | while read -r dir; do 2563 find "${path}" -type d | sort -r | while read -r dir; do
1926 rmdir "${dir}" 2> /dev/null && echo "${_CYAN}<<< ${dir}${_NORMAL}" 2564 if rmdir "${dir}" 2> /dev/null; then
2565 echo "${_CYAN}<<< ${dir}${_NORMAL}"
2566 fi
1927 done 2567 done
1928 fi 2568 fi
1929 elif [[ "${path}" == *.py ]]; then 2569 elif [[ "${path}" == *.py ]]; then
1930 base_module_name="${path##*/}" 2570 base_module_name="${path##*/}"
1931 base_module_name="${base_module_name%.py}" 2571 base_module_name="${base_module_name%.py}"
1961 if [[ "${dir}" == "__pycache__" ]]; then 2601 if [[ "${dir}" == "__pycache__" ]]; then
1962 base_module_name="${compiled_file##*/}" 2602 base_module_name="${compiled_file##*/}"
1963 base_module_name="${base_module_name%\$py.class}" 2603 base_module_name="${base_module_name%\$py.class}"
1964 py_file="${compiled_file%__pycache__/*}${base_module_name}.py" 2604 py_file="${compiled_file%__pycache__/*}${base_module_name}.py"
1965 else 2605 else
1966 py_file="${compiled_file%\$py.class}" 2606 py_file="${compiled_file%\$py.class}.py"
1967 fi 2607 fi
1968 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then 2608 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
1969 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue 2609 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
1970 else 2610 else
1971 [[ -f "${py_file}" ]] && continue 2611 [[ -f "${py_file}" ]] && continue
1977 fi 2617 fi
1978 2618
1979 # Delete empty parent directories. 2619 # Delete empty parent directories.
1980 dir="${compiled_file%/*}" 2620 dir="${compiled_file%/*}"
1981 while [[ "${dir}" != "${root}" ]]; do 2621 while [[ "${dir}" != "${root}" ]]; do
1982 if rmdir "${compiled_file%/*}" 2> /dev/null; then 2622 if rmdir "${dir}" 2> /dev/null; then
1983 echo "${_CYAN}<<< ${compiled_file%/*}${_NORMAL}" 2623 echo "${_CYAN}<<< ${dir}${_NORMAL}"
1984 else 2624 else
1985 break 2625 break
1986 fi 2626 fi
1987 dir="${dir%/*}" 2627 dir="${dir%/*}"
1988 done 2628 done
1989 done 2629 done
1990 done 2630 done
1991} 2631}
1992 2632
1993# @FUNCTION: python_mod_optimize 2633# @FUNCTION: python_mod_optimize
1994# @USAGE: [options] [directory|file] 2634# @USAGE: [--allow-evaluated-non-sitedir-paths] [-d directory] [-f] [-l] [-q] [-x regular_expression] [--] <file|directory> [files|directories]
1995# @DESCRIPTION: 2635# @DESCRIPTION:
1996# If no arguments supplied, it will recompile not recursively all modules 2636# Byte-compile specified Python modules.
1997# under sys.path (eg. /usr/lib/python2.6, /usr/lib/python2.6/site-packages).
1998#
1999# If supplied with arguments, it will recompile all modules recursively
2000# in the supplied directory.
2001#
2002# Options passed to this function are passed to compileall.py. 2637# -d, -f, -l, -q and -x options passed to this function are passed to compileall.py.
2003# 2638#
2004# This function can be used only in pkg_postinst() phase. 2639# This function can be used only in pkg_postinst() phase.
2005python_mod_optimize() { 2640python_mod_optimize() {
2641 if [[ "${EBUILD_PHASE}" != "postinst" ]]; then
2642 die "${FUNCNAME}() can be used only in pkg_postinst() phase"
2643 fi
2644
2645 _python_check_python_pkg_setup_execution
2006 _python_initialize_prefix_variables 2646 _python_initialize_prefix_variables
2007 2647
2008 # Check if phase is pkg_postinst(). 2648 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
2009 [[ "${EBUILD_PHASE}" != "postinst" ]] && die "${FUNCNAME}() can be used only in pkg_postinst() phase"
2010
2011 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2012 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs. 2649 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs.
2013 local dir file iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_absolute_dirs=() site_packages_dirs=() site_packages_absolute_files=() site_packages_files=() 2650 local allow_evaluated_non_sitedir_paths="0" dir dirs=() evaluated_dirs=() evaluated_files=() file files=() iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_dirs=() site_packages_files=() stderr stderr_line
2014 2651
2015 if _python_package_supporting_installation_for_multiple_python_abis; then 2652 if _python_package_supporting_installation_for_multiple_python_abis; then
2016 if [[ -z "${PYTHON_ABIS}" ]]; then 2653 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
2017 die "${FUNCNAME}(): Environment not initialized" 2654 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2018 fi 2655 fi
2019 iterated_PYTHON_ABIS="${PYTHON_ABIS}" 2656 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
2020 else 2657 else
2658 if has "${EAPI:-0}" 0 1 2 3; then
2021 iterated_PYTHON_ABIS="${PYTHON_ABI:=$(PYTHON --ABI)}" 2659 iterated_PYTHON_ABIS="${PYTHON_ABI:=$(PYTHON --ABI)}"
2660 else
2661 iterated_PYTHON_ABIS="${PYTHON_ABI}"
2662 fi
2022 fi 2663 fi
2023 2664
2024 # Strip trailing slash from EROOT. 2665 # Strip trailing slash from EROOT.
2025 root="${EROOT%/}" 2666 root="${EROOT%/}"
2026 2667
2027 while (($#)); do 2668 while (($#)); do
2028 case "$1" in 2669 case "$1" in
2670 --allow-evaluated-non-sitedir-paths)
2671 allow_evaluated_non_sitedir_paths="1"
2672 ;;
2029 -l|-f|-q) 2673 -l|-f|-q)
2030 options+=("$1") 2674 options+=("$1")
2031 ;; 2675 ;;
2032 -d|-x) 2676 -d|-x)
2033 options+=("$1" "$2") 2677 options+=("$1" "$2")
2034 shift 2678 shift
2035 ;; 2679 ;;
2680 --)
2681 shift
2682 break
2683 ;;
2036 -*) 2684 -*)
2037 ewarn "${FUNCNAME}(): Ignoring option '$1'" 2685 die "${FUNCNAME}(): Unrecognized option '$1'"
2038 ;; 2686 ;;
2039 *) 2687 *)
2040 break 2688 break
2041 ;; 2689 ;;
2042 esac 2690 esac
2043 shift 2691 shift
2044 done 2692 done
2045 2693
2694 if [[ "${allow_evaluated_non_sitedir_paths}" == "1" ]] && ! _python_package_supporting_installation_for_multiple_python_abis; then
2695 die "${FUNCNAME}(): '--allow-evaluated-non-sitedir-paths' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2696 fi
2697
2046 if [[ "$#" -eq 0 ]]; then 2698 if [[ "$#" -eq 0 ]]; then
2047 _python_set_color_variables 2699 die "${FUNCNAME}(): Missing files or directories"
2048
2049 echo
2050 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: Not passing of paths to ${FUNCNAME}() is deprecated and will be${_NORMAL}"
2051 echo " ${_RED}*${_NORMAL} ${_RED}disallowed on 2010-09-01. Call ${FUNCNAME}() with paths to Python modules.${_NORMAL}"
2052 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2053 echo
2054
2055 einfo &> /dev/null
2056 einfo "Deprecation Warning: Not passing of paths to ${FUNCNAME}() is deprecated and will be" &> /dev/null
2057 einfo "disallowed on 2010-09-01. Call ${FUNCNAME}() with paths to Python modules." &> /dev/null
2058 einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2059 einfo &> /dev/null
2060 fi 2700 fi
2061 2701
2062 while (($#)); do 2702 while (($#)); do
2703 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2704 die "${FUNCNAME}(): Invalid argument '$1'"
2063 if ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then 2705 elif ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
2064 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories" 2706 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories"
2065 elif [[ "$1" =~ ^/ ]]; then 2707 elif [[ "$1" =~ ^/ ]]; then
2066 if _python_package_supporting_installation_for_multiple_python_abis; then 2708 if _python_package_supporting_installation_for_multiple_python_abis; then
2709 if [[ "${allow_evaluated_non_sitedir_paths}" != "1" ]]; then
2067 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs" 2710 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
2068 fi 2711 fi
2069 if [[ -d "${root}$1" ]]; then 2712 if [[ "$1" != *\$* ]]; then
2070 other_dirs+=("${root}$1") 2713 die "${FUNCNAME}(): '$1' has invalid syntax"
2071 elif [[ -f "${root}$1" ]]; then 2714 fi
2072 other_files+=("${root}$1") 2715 if [[ "$1" == *.py ]]; then
2073 elif [[ -e "${root}$1" ]]; then 2716 evaluated_files+=("$1")
2074 eerror "'${root}$1' is not a file or a directory!" 2717 else
2718 evaluated_dirs+=("$1")
2719 fi
2075 else 2720 else
2721 if [[ -d "${root}$1" ]]; then
2722 other_dirs+=("${root}$1")
2723 elif [[ -f "${root}$1" ]]; then
2724 other_files+=("${root}$1")
2725 elif [[ -e "${root}$1" ]]; then
2726 eerror "${FUNCNAME}(): '${root}$1' is not a regular file or a directory"
2727 else
2076 eerror "'${root}$1' does not exist!" 2728 eerror "${FUNCNAME}(): '${root}$1' does not exist"
2729 fi
2077 fi 2730 fi
2078 else 2731 else
2079 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 2732 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2080 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then 2733 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
2081 site_packages_dirs+=("$1") 2734 site_packages_dirs+=("$1")
2082 break 2735 break
2083 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then 2736 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
2084 site_packages_files+=("$1") 2737 site_packages_files+=("$1")
2085 break 2738 break
2086 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then 2739 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
2087 eerror "'$1' is not a file or a directory!" 2740 eerror "${FUNCNAME}(): '$1' is not a regular file or a directory"
2088 else 2741 else
2089 eerror "'$1' does not exist!" 2742 eerror "${FUNCNAME}(): '$1' does not exist"
2090 fi 2743 fi
2091 done 2744 done
2092 fi 2745 fi
2093 shift 2746 shift
2094 done 2747 done
2095 2748
2096 # Set additional options. 2749 # Set additional options.
2097 options+=("-q") 2750 options+=("-q")
2098 2751
2099 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 2752 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2100 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})); then 2753 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then
2101 return_code="0" 2754 return_code="0"
2755 stderr=""
2102 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)" 2756 ebegin "Compilation and optimization of Python modules for $(python_get_implementation_and_version)"
2103 if ((${#site_packages_dirs[@]})); then 2757 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then
2104 for dir in "${site_packages_dirs[@]}"; do 2758 for dir in "${site_packages_dirs[@]}"; do
2105 site_packages_absolute_dirs+=("${root}$(python_get_sitedir)/${dir}") 2759 dirs+=("${root}$(python_get_sitedir)/${dir}")
2106 done 2760 done
2761 for dir in "${evaluated_dirs[@]}"; do
2762 eval "dirs+=(\"\${root}${dir}\")"
2763 done
2107 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" || return_code="1" 2764 stderr+="${stderr:+$'\n'}$("$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" 2>&1)" || return_code="1"
2108 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2765 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
2109 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" &> /dev/null || return_code="1" 2766 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1"
2110 fi 2767 fi
2111 _python_clean_compiled_modules "${site_packages_absolute_dirs[@]}" 2768 _python_clean_compiled_modules "${dirs[@]}"
2112 fi 2769 fi
2113 if ((${#site_packages_files[@]})); then 2770 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then
2114 for file in "${site_packages_files[@]}"; do 2771 for file in "${site_packages_files[@]}"; do
2115 site_packages_absolute_files+=("${root}$(python_get_sitedir)/${file}") 2772 files+=("${root}$(python_get_sitedir)/${file}")
2116 done 2773 done
2774 for file in "${evaluated_files[@]}"; do
2775 eval "files+=(\"\${root}${file}\")"
2776 done
2117 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" || return_code="1" 2777 stderr+="${stderr:+$'\n'}$("$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" 2>&1)" || return_code="1"
2118 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2778 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
2119 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" &> /dev/null || return_code="1" 2779 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" &> /dev/null || return_code="1"
2120 fi 2780 fi
2121 _python_clean_compiled_modules "${site_packages_absolute_files[@]}" 2781 _python_clean_compiled_modules "${files[@]}"
2122 fi 2782 fi
2123 eend "${return_code}" 2783 eend "${return_code}"
2784 if [[ -n "${stderr}" ]]; then
2785 eerror "Syntax errors / warnings in Python modules for $(python_get_implementation_and_version):" &> /dev/null
2786 while read stderr_line; do
2787 eerror " ${stderr_line}"
2788 done <<< "${stderr}"
2124 fi 2789 fi
2125 unset site_packages_absolute_dirs site_packages_absolute_files 2790 fi
2791 unset dirs files
2126 done 2792 done
2127 2793
2128 if _python_package_supporting_installation_for_multiple_python_abis; then 2794 if _python_package_supporting_installation_for_multiple_python_abis; then
2129 # Restore previous value of PYTHON_ABI. 2795 # Restore previous value of PYTHON_ABI.
2130 if [[ -n "${previous_PYTHON_ABI}" ]]; then 2796 if [[ -n "${previous_PYTHON_ABI}" ]]; then
2134 fi 2800 fi
2135 fi 2801 fi
2136 2802
2137 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then 2803 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
2138 return_code="0" 2804 return_code="0"
2805 stderr=""
2139 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version)" 2806 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation_and_version)"
2140 if ((${#other_dirs[@]})); then 2807 if ((${#other_dirs[@]})); then
2141 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1" 2808 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" 2>&1)" || return_code="1"
2142 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2809 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
2143 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1" 2810 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
2144 fi 2811 fi
2145 _python_clean_compiled_modules "${other_dirs[@]}" 2812 _python_clean_compiled_modules "${other_dirs[@]}"
2146 fi 2813 fi
2147 if ((${#other_files[@]})); then 2814 if ((${#other_files[@]})); then
2148 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1" 2815 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" 2>&1)" || return_code="1"
2149 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2816 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
2150 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1" 2817 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1"
2151 fi 2818 fi
2152 _python_clean_compiled_modules "${other_dirs[@]}" 2819 _python_clean_compiled_modules "${other_files[@]}"
2153 fi 2820 fi
2154 eend "${return_code}" 2821 eend "${return_code}"
2822 if [[ -n "${stderr}" ]]; then
2823 eerror "Syntax errors / warnings in Python modules placed outside of site-packages directories for $(python_get_implementation_and_version):" &> /dev/null
2824 while read stderr_line; do
2825 eerror " ${stderr_line}"
2826 done <<< "${stderr}"
2827 fi
2155 fi 2828 fi
2156 else 2829 else
2157 # Deprecated part of python_mod_optimize() 2830 # Deprecated part of python_mod_optimize()
2831 ewarn
2832 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
2833 ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-08-01."
2834 ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
2835 ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
2836 ewarn
2158 2837
2159 local myroot mydirs=() myfiles=() myopts=() return_code="0" 2838 local myroot mydirs=() myfiles=() myopts=() return_code="0"
2160 2839
2161 # strip trailing slash 2840 # strip trailing slash
2162 myroot="${EROOT%/}" 2841 myroot="${EROOT%/}"
2169 ;; 2848 ;;
2170 -d|-x) 2849 -d|-x)
2171 myopts+=("$1" "$2") 2850 myopts+=("$1" "$2")
2172 shift 2851 shift
2173 ;; 2852 ;;
2853 --)
2854 shift
2855 break
2856 ;;
2174 -*) 2857 -*)
2175 ewarn "${FUNCNAME}(): Ignoring option '$1'" 2858 die "${FUNCNAME}(): Unrecognized option '$1'"
2176 ;; 2859 ;;
2177 *) 2860 *)
2178 break 2861 break
2179 ;; 2862 ;;
2180 esac 2863 esac
2181 shift 2864 shift
2182 done 2865 done
2183 2866
2184 if [[ "$#" -eq 0 ]]; then 2867 if [[ "$#" -eq 0 ]]; then
2185 _python_set_color_variables 2868 die "${FUNCNAME}(): Missing files or directories"
2186
2187 echo
2188 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: Not passing of paths to ${FUNCNAME}() is deprecated and will be${_NORMAL}"
2189 echo " ${_RED}*${_NORMAL} ${_RED}disallowed on 2010-09-01. Call ${FUNCNAME}() with paths to Python modules.${_NORMAL}"
2190 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2191 echo
2192
2193 einfo &> /dev/null
2194 einfo "Deprecation Warning: Not passing of paths to ${FUNCNAME}() is deprecated and will be" &> /dev/null
2195 einfo "disallowed on 2010-09-01. Call ${FUNCNAME}() with paths to Python modules." &> /dev/null
2196 einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2197 einfo &> /dev/null
2198 fi 2869 fi
2199 2870
2200 while (($#)); do 2871 while (($#)); do
2872 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2873 die "${FUNCNAME}(): Invalid argument '$1'"
2201 if [[ -d "${myroot}/${1#/}" ]]; then 2874 elif [[ -d "${myroot}/${1#/}" ]]; then
2202 mydirs+=("${myroot}/${1#/}") 2875 mydirs+=("${myroot}/${1#/}")
2203 elif [[ -f "${myroot}/${1#/}" ]]; then 2876 elif [[ -f "${myroot}/${1#/}" ]]; then
2204 # Files are passed to python_mod_compile which is EROOT-aware 2877 myfiles+=("${myroot}/${1#/}")
2205 myfiles+=("$1")
2206 elif [[ -e "${myroot}/${1#/}" ]]; then 2878 elif [[ -e "${myroot}/${1#/}" ]]; then
2207 eerror "${myroot}/${1#/} is not a file or directory!" 2879 eerror "${FUNCNAME}(): ${myroot}/${1#/} is not a regular file or directory"
2208 else 2880 else
2209 eerror "${myroot}/${1#/} does not exist!" 2881 eerror "${FUNCNAME}(): ${myroot}/${1#/} does not exist"
2210 fi 2882 fi
2211 shift 2883 shift
2212 done 2884 done
2213 2885
2214 # set additional opts 2886 # set additional opts
2222 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1" 2894 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1"
2223 _python_clean_compiled_modules "${mydirs[@]}" 2895 _python_clean_compiled_modules "${mydirs[@]}"
2224 fi 2896 fi
2225 2897
2226 if ((${#myfiles[@]})); then 2898 if ((${#myfiles[@]})); then
2899 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" || return_code="1"
2900 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null || return_code="1"
2227 python_mod_compile "${myfiles[@]}" 2901 _python_clean_compiled_modules "${myfiles[@]}"
2228 fi 2902 fi
2229 2903
2230 eend "${return_code}" 2904 eend "${return_code}"
2231 fi 2905 fi
2232} 2906}
2233 2907
2234# @FUNCTION: python_mod_cleanup 2908# @FUNCTION: python_mod_cleanup
2235# @USAGE: [directory|file] 2909# @USAGE: [--allow-evaluated-non-sitedir-paths] [--] <file|directory> [files|directories]
2236# @DESCRIPTION: 2910# @DESCRIPTION:
2237# Run with optional arguments, where arguments are Python modules. If none given, 2911# Delete orphaned byte-compiled Python modules corresponding to specified Python modules.
2238# it will look in /usr/lib/python[0-9].[0-9].
2239#
2240# It will recursively scan all compiled Python modules in the directories and
2241# determine if they are orphaned (i.e. their corresponding .py files are missing.)
2242# If they are, then it will remove their corresponding .pyc and .pyo files.
2243# 2912#
2244# This function can be used only in pkg_postrm() phase. 2913# This function can be used only in pkg_postrm() phase.
2245python_mod_cleanup() { 2914python_mod_cleanup() {
2915 if [[ "${EBUILD_PHASE}" != "postrm" ]]; then
2916 die "${FUNCNAME}() can be used only in pkg_postrm() phase"
2917 fi
2918
2919 _python_check_python_pkg_setup_execution
2246 _python_initialize_prefix_variables 2920 _python_initialize_prefix_variables
2247 2921
2248 local dir iterated_PYTHON_ABIS PYTHON_ABI="${PYTHON_ABI}" root search_paths=() sitedir 2922 local allow_evaluated_non_sitedir_paths="0" dir iterated_PYTHON_ABIS PYTHON_ABI="${PYTHON_ABI}" root search_paths=() sitedir
2249
2250 # Check if phase is pkg_postrm().
2251 [[ "${EBUILD_PHASE}" != "postrm" ]] && die "${FUNCNAME}() can be used only in pkg_postrm() phase"
2252 2923
2253 if _python_package_supporting_installation_for_multiple_python_abis; then 2924 if _python_package_supporting_installation_for_multiple_python_abis; then
2254 if [[ -z "${PYTHON_ABIS}" ]]; then 2925 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
2255 die "${FUNCNAME}(): Environment not initialized" 2926 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2256 fi 2927 fi
2257 iterated_PYTHON_ABIS="${PYTHON_ABIS}" 2928 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
2258 else 2929 else
2930 if has "${EAPI:-0}" 0 1 2 3; then
2259 iterated_PYTHON_ABIS="${PYTHON_ABI:-$(PYTHON --ABI)}" 2931 iterated_PYTHON_ABIS="${PYTHON_ABI:-$(PYTHON --ABI)}"
2932 else
2933 iterated_PYTHON_ABIS="${PYTHON_ABI}"
2934 fi
2260 fi 2935 fi
2261 2936
2262 # Strip trailing slash from EROOT. 2937 # Strip trailing slash from EROOT.
2263 root="${EROOT%/}" 2938 root="${EROOT%/}"
2264 2939
2940 while (($#)); do
2941 case "$1" in
2942 --allow-evaluated-non-sitedir-paths)
2943 allow_evaluated_non_sitedir_paths="1"
2944 ;;
2945 --)
2946 shift
2947 break
2948 ;;
2949 -*)
2950 die "${FUNCNAME}(): Unrecognized option '$1'"
2951 ;;
2952 *)
2953 break
2954 ;;
2955 esac
2956 shift
2957 done
2958
2959 if [[ "${allow_evaluated_non_sitedir_paths}" == "1" ]] && ! _python_package_supporting_installation_for_multiple_python_abis; then
2960 die "${FUNCNAME}(): '--allow-evaluated-non-sitedir-paths' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2961 fi
2962
2265 if [[ "$#" -gt 0 ]]; then 2963 if [[ "$#" -eq 0 ]]; then
2266 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then 2964 die "${FUNCNAME}(): Missing files or directories"
2965 fi
2966
2967 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
2267 while (($#)); do 2968 while (($#)); do
2969 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2970 die "${FUNCNAME}(): Invalid argument '$1'"
2268 if ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then 2971 elif ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
2269 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories" 2972 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories"
2270 elif [[ "$1" =~ ^/ ]]; then 2973 elif [[ "$1" =~ ^/ ]]; then
2271 if _python_package_supporting_installation_for_multiple_python_abis; then 2974 if _python_package_supporting_installation_for_multiple_python_abis; then
2975 if [[ "${allow_evaluated_non_sitedir_paths}" != "1" ]]; then
2272 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs" 2976 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
2273 fi 2977 fi
2978 if [[ "$1" != *\$* ]]; then
2979 die "${FUNCNAME}(): '$1' has invalid syntax"
2980 fi
2981 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2982 eval "search_paths+=(\"\${root}$1\")"
2983 done
2984 else
2274 search_paths+=("${root}$1") 2985 search_paths+=("${root}$1")
2986 fi
2275 else 2987 else
2276 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 2988 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2277 search_paths+=("${root}$(python_get_sitedir)/$1") 2989 search_paths+=("${root}$(python_get_sitedir)/$1")
2278 done
2279 fi
2280 shift
2281 done
2282 else
2283 # Deprecated part of python_mod_cleanup()
2284
2285 search_paths=("${@#/}")
2286 search_paths=("${search_paths[@]/#/${root}/}")
2287 fi
2288 else
2289 _python_set_color_variables
2290
2291 echo
2292 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: Not passing of paths to ${FUNCNAME}() is deprecated and will be${_NORMAL}"
2293 echo " ${_RED}*${_NORMAL} ${_RED}disallowed on 2010-09-01. Call ${FUNCNAME}() with paths to Python modules.${_NORMAL}"
2294 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2295 echo
2296
2297 einfo &> /dev/null
2298 einfo "Deprecation Warning: Not passing of paths to ${FUNCNAME}() is deprecated and will be" &> /dev/null
2299 einfo "disallowed on 2010-09-01. Call ${FUNCNAME}() with paths to Python modules." &> /dev/null
2300 einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2301 einfo &> /dev/null
2302
2303 for dir in "${root}"/usr/lib*; do
2304 if [[ -d "${dir}" && ! -L "${dir}" ]]; then
2305 for sitedir in "${dir}"/python*/site-packages; do
2306 if [[ -d "${sitedir}" ]]; then
2307 search_paths+=("${sitedir}")
2308 fi
2309 done 2990 done
2310 fi 2991 fi
2992 shift
2311 done 2993 done
2312 for sitedir in "${root}"/usr/share/jython-*/Lib/site-packages; do 2994 else
2313 if [[ -d "${sitedir}" ]]; then 2995 # Deprecated part of python_mod_cleanup()
2996 ewarn
2997 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
2998 ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-08-01."
2999 ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
3000 ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
3001 ewarn
3002
2314 search_paths+=("${sitedir}") 3003 search_paths=("${@#/}")
2315 fi 3004 search_paths=("${search_paths[@]/#/${root}/}")
2316 done
2317 fi 3005 fi
2318 3006
2319 _python_clean_compiled_modules "${search_paths[@]}" 3007 _python_clean_compiled_modules "${search_paths[@]}"
2320} 3008}
2321 3009
2322# ================================================================================================ 3010# ================================================================================================
2323# ===================================== DEPRECATED FUNCTIONS ===================================== 3011# ===================================== DEPRECATED FUNCTIONS =====================================
2324# ================================================================================================ 3012# ================================================================================================
2325
2326# @FUNCTION: python_version
2327# @DESCRIPTION:
2328# Run without arguments and it will export the version of python
2329# currently in use as $PYVER; sets PYVER/PYVER_MAJOR/PYVER_MINOR
2330python_version() {
2331 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2332 eerror "Use PYTHON() and/or python_get_*() instead of ${FUNCNAME}()."
2333 die "${FUNCNAME}() cannot be used in this EAPI"
2334 fi
2335
2336 _python_set_color_variables
2337
2338 if [[ "${FUNCNAME[1]}" != "distutils_python_version" ]]; then
2339 echo
2340 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01.${_NORMAL}"
2341 echo " ${_RED}*${_NORMAL} ${_RED}Use PYTHON() instead of python variable. Use python_get_*() instead of PYVER* variables.${_NORMAL}"
2342 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2343 echo
2344
2345 einfo &> /dev/null
2346 einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01." &> /dev/null
2347 einfo "Use PYTHON() instead of python variable. Use python_get_*() instead of PYVER* variables." &> /dev/null
2348 einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2349 einfo &> /dev/null
2350 fi
2351
2352 [[ -n "${PYVER}" ]] && return 0
2353 local tmpstr
2354 python="${python:-${EPREFIX}/usr/bin/python}"
2355 tmpstr="$(EPYTHON= ${python} -V 2>&1 )"
2356 export PYVER_ALL="${tmpstr#Python }"
2357 export PYVER_MAJOR="${PYVER_ALL:0:1}"
2358 export PYVER_MINOR="${PYVER_ALL:2:1}"
2359 if [[ "${PYVER_ALL:3:1}" == "." ]]; then
2360 export PYVER_MICRO="${PYVER_ALL:4}"
2361 fi
2362 export PYVER="${PYVER_MAJOR}.${PYVER_MINOR}"
2363}
2364
2365# @FUNCTION: python_mod_exists
2366# @USAGE: <module>
2367# @DESCRIPTION:
2368# Run with the module name as an argument. It will check if a
2369# Python module is installed and loadable. It will return
2370# TRUE(0) if the module exists, and FALSE(1) if the module does
2371# not exist.
2372#
2373# Example:
2374# if python_mod_exists gtk; then
2375# echo "gtk support enabled"
2376# fi
2377python_mod_exists() {
2378 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2379 eerror "Use USE dependencies and/or has_version() instead of ${FUNCNAME}()."
2380 die "${FUNCNAME}() cannot be used in this EAPI"
2381 fi
2382
2383 _python_set_color_variables
2384
2385 echo
2386 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01.${_NORMAL}"
2387 echo " ${_RED}*${_NORMAL} ${_RED}Use USE dependencies and/or has_version() instead of ${FUNCNAME}().${_NORMAL}"
2388 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2389 echo
2390
2391 eerror &> /dev/null
2392 eerror "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01." &> /dev/null
2393 eerror "Use USE dependencies and/or has_version() instead of ${FUNCNAME}()." &> /dev/null
2394 eerror "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2395 eerror &> /dev/null
2396
2397 if [[ "$#" -ne 1 ]]; then
2398 die "${FUNCNAME}() requires 1 argument"
2399 fi
2400 "$(PYTHON ${PYTHON_ABI})" -c "import $1" &> /dev/null
2401}
2402
2403# @FUNCTION: python_tkinter_exists
2404# @DESCRIPTION:
2405# Run without arguments, checks if Python was compiled with Tkinter
2406# support. If not, prints an error message and dies.
2407python_tkinter_exists() {
2408 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2409 eerror "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()."
2410 die "${FUNCNAME}() cannot be used in this EAPI"
2411 fi
2412
2413 _python_set_color_variables
2414
2415 if [[ "${FUNCNAME[1]}" != "distutils_python_tkinter" ]]; then
2416 echo
2417 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01.${_NORMAL}"
2418 echo " ${_RED}*${_NORMAL} ${_RED}Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}().${_NORMAL}"
2419 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2420 echo
2421
2422 eerror &> /dev/null
2423 eerror "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01." &> /dev/null
2424 eerror "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()." &> /dev/null
2425 eerror "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2426 eerror &> /dev/null
2427 fi
2428
2429 if ! "$(PYTHON ${PYTHON_ABI})" -c "from sys import version_info
2430if version_info[0] == 3:
2431 import tkinter
2432else:
2433 import Tkinter" &> /dev/null; then
2434 eerror "Python needs to be rebuilt with tkinter support enabled."
2435 eerror "Add the following line to '${EPREFIX}/etc/portage/package.use' and rebuild Python"
2436 eerror "dev-lang/python tk"
2437 die "Python installed without support for tkinter"
2438 fi
2439}
2440
2441# @FUNCTION: python_mod_compile
2442# @USAGE: <file> [more files ...]
2443# @DESCRIPTION:
2444# Given filenames, it will pre-compile the module's .pyc and .pyo.
2445# This function can be used only in pkg_postinst() phase.
2446#
2447# Example:
2448# python_mod_compile /usr/lib/python2.3/site-packages/pygoogle.py
2449#
2450python_mod_compile() {
2451 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2452 eerror "Use python_mod_optimize() instead of ${FUNCNAME}()."
2453 die "${FUNCNAME}() cannot be used in this EAPI"
2454 fi
2455
2456 _python_initialize_prefix_variables
2457 _python_set_color_variables
2458
2459 if [[ "${FUNCNAME[1]}" != "python_mod_optimize" ]]; then
2460 echo
2461 echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-09-01.${_NORMAL}"
2462 echo " ${_RED}*${_NORMAL} ${_RED}Use python_mod_optimize() instead of ${FUNCNAME}().${_NORMAL}"
2463 echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2464 echo
2465
2466 einfo &> /dev/null
2467 einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-09-01." &> /dev/null
2468 einfo "Use python_mod_optimize() instead of ${FUNCNAME}()." &> /dev/null
2469 einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2470 einfo &> /dev/null
2471 fi
2472
2473 local f myroot myfiles=()
2474
2475 # Check if phase is pkg_postinst()
2476 [[ "${EBUILD_PHASE}" != "postinst" ]] && die "${FUNCNAME}() can be used only in pkg_postinst() phase"
2477
2478 # strip trailing slash
2479 myroot="${EROOT%/}"
2480
2481 # respect EROOT
2482 for f in "$@"; do
2483 [[ -f "${myroot}/${f}" ]] && myfiles+=("${myroot}/${f}")
2484 done
2485
2486 PYTHON_ABI="$(PYTHON --ABI)"
2487
2488 if ((${#myfiles[@]})); then
2489 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}"
2490 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null
2491 _python_clean_compiled_modules "${myfiles[@]}"
2492 else
2493 ewarn "No files to compile!"
2494 fi
2495}

Legend:
Removed from v.1.99  
changed lines
  Added in v.1.124

  ViewVC Help
Powered by ViewVC 1.1.20